////////////////////////////////////////////////////////////////////////
// pageelems.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.pageelems")

// <%pre>
#line 1 "pageelems.ecpp"

#include "../services.h"

#include <livefeatures.h>
#include <setup.h>
#include <timers.h>
#include <tools.h>
#include <epg_events.h>
#include <gen_version_suffix.h>
#include <tntfeatures.h>

using namespace vdrlive;

std::string toString(const std::vector<std::string> &vec) {
  if (vec.size() == 0) return "";
  std::string result;
  for (const std::string &str:vec) {
    if (!result.empty() ) result.append(", ");
    result.append(str);
  }
  return result;
}
  
/*
std::string toString(const std::vector<int> &vec) {
  if (vec.size() == 0) return "";
  std::string result;
  for (const int &i:vec) {
    if (!result.empty() ) result.append(", ");
    result.append(cToSvInt(i) );
  }
  return result;
}
*/
  
std::string toString(const std::vector<cActor> &vec) {
  if (vec.size() == 0) return "";
  std::string result;
  for (const cActor &actor:vec) {
    if (!result.empty() ) result.append(", ");
    result.append(actor.name);
    if (!actor.role.empty() ) {
      result.append(" (");
      result.append(actor.role);
      result.append(")");
    }
  }
  return result;
}
bool getLanguage(std::string &language, const char *env_name) {
  const char *env_language = std::getenv(env_name);
  bool found = env_language && strlen(env_language) >= 2;
  if (found) language.append(env_language, 2);
  return found;
}


// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class doc_type_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        doc_type_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class create_html_js_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        create_html_js_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class stylesheets_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        stylesheets_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class logo_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        logo_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class hide_element_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        hide_element_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class progressbar_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        progressbar_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class ajax_action_href_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        ajax_action_href_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class imdb_info_href_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        imdb_info_href_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class hls_channel_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        hls_channel_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class m3u_playlist_channel_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        m3u_playlist_channel_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class m3u_playlist_recording_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        m3u_playlist_recording_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class stream_recording_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        stream_recording_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class event_timer_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        event_timer_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class edit_timer_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        edit_timer_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class ajax_js_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        ajax_js_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class infobox_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        infobox_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class epg_tool_box_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        epg_tool_box_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class epg_tt_box_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        epg_tt_box_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class media_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        media_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class about_tt_box_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        about_tt_box_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    doc_type_type doc_type;
    create_html_js_type create_html_js;
    stylesheets_type stylesheets;
    logo_type logo;
    hide_element_type hide_element;
    progressbar_type progressbar;
    ajax_action_href_type ajax_action_href;
    imdb_info_href_type imdb_info_href;
    hls_channel_type hls_channel;
    m3u_playlist_channel_type m3u_playlist_channel;
    m3u_playlist_recording_type m3u_playlist_recording;
    stream_recording_type stream_recording;
    event_timer_type event_timer;
    edit_timer_type edit_timer;
    ajax_js_type ajax_js;
    infobox_type infobox;
    epg_tool_box_type epg_tool_box;
    epg_tt_box_type epg_tt_box;
    media_type media;
    about_tt_box_type about_tt_box;
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("pageelems");

static const char* rawData = "\270\006\000\000\271\006\000\000\273\006\000\000)\007\000\000*\007\000\000,\007\000\000("
  "\010\000\000\302\t\000\000\342\t\000\000\027\n\000\000#\n\000\000/\n\000\000v\n\000\000\202\n\000\000\216\n\000\000"
  "\307\n\000\000\323\n\000\000\337\n\000\000\231\013\000\000\025\014\000\000\244\015\000\000\265\015\000\000\301\015"
  "\000\000\032\017\000\000#\017\000\000\236\017\000\000\247\017\000\000\301\017\000\000)\020\000\0002\020\000\000;\020"
  "\000\000W\020\000\000\206\021\000\000\010\022\000\000\037\022\000\000\t\025\000\000\015\025\000\000\211\027\000\000"
  "\015\030\000\000P\030\000\000G\031\000\000\202\032\000\000\206\032\000\000\007\035\000\000\t\035\000\000u\035\000\000"
  "A\036\000\000B\036\000\000D\036\000\000\013\037\000\000%\037\000\000.\037\000\000;\037\000\000a\037\000\000\210\037"
  "\000\000\211\037\000\000\213\037\000\000\245\037\000\000\246\037\000\000\250\037\000\000\264\037\000\000\315\037\000"
  "\000\321\037\000\000\323\037\000\000\341\037\000\000\361\037\000\000\362\037\000\000\364\037\000\000\367\037\000\000"
  "\373\037\000\000\375\037\000\000\020 \000\000\027 \000\000\031 \000\000\032 \000\000% \000\000, \000\0005 \000\0006 "
  "\000\0008 \000\000b \000\000d \000\000\207 \000\000\211 \000\000\244 \000\000\255 \000\000\265 \000\000\266 \000\000"
  "\270 \000\000\333 \000\000\347 \000\000\360 \000\000\370 \000\000\371 \000\000\373 \000\000\035!\000\000)!\000\0002!"
  "\000\000:!\000\000;!\000\000=!\000\000F!\000\000[!\000\000d!\000\000h!\000\000m!\000\000n!\000\000o!\000\000q!\000"
  "\000\213!\000\000\214!\000\000\233!\000\000\244!\000\000\250!\000\000\255!\000\000\256!\000\000\260!\000\000\262!\000"
  "\000\263!\000\000\324!\000\000\340!\000\000\351!\000\000\361!\000\000\362!\000\000\364!\000\000\026\"\000\000\"\"\000"
  "\000+\"\000\0003\"\000\0005\"\000\0007\"\000\000x$\000\000\213$\000\000\305$\000\000\317$\000\000\354$\000\000\366$"
  "\000\000\023%\000\000\363%\000\000S&\000\000T&\000\000V&\000\000\315&\000\000\006(\000\000&(\000\000\202(\000\000\207"
  "(\000\000\214(\000\000\221(\000\000\226(\000\000\313(\000\000\320(\000\000\370(\000\000U)\000\000\177)\000\000\226)"
  "\000\000\227)\000\000\231)\000\000\232)\000\000\233)\000\000\236)\000\000\237)\000\000\310)\000\000\324)\000\000\335)"
  "\000\000\345)\000\000\346)\000\000\350)\000\000\351)\000\000\353)\000\000\354)\000\0001*\000\000;*\000\000x*\000\000|"
  "*\000\000\200*\000\000\226*\000\000\262*\000\000\264*\000\000\272*\000\000\316*\000\000\320*\000\000\330*\000\000\354"
  "*\000\000\362*\000\000\035+\000\000)+\000\0002+\000\000A+\000\000U+\000\000W+\000\000_+\000\000s+\000\000u+\000\000}+"
  "\000\000\221+\000\000\224+\000\000\227+\000\000\230+\000\000\240+\000\000\241+\000\000\243+\000\000\305+\000\000\002,"
  "\000\000#,\000\000W,\000\000\134,\000\000j,\000\000\242,\000\000\246,\000\000\264,\000\000\353,\000\000\360,\000\000"
  "\376,\000\0006-\000\000;-\000\000G-\000\000\134-\000\000c-\000\000\315-\000\000%.\000\0008.\000\000:.\000\000Q.\000"
  "\000S.\000\000[.\000\000|.\000\000\211.\000\000\255.\000\000\316.\000\000\326.\000\000\342.\000\000\343.\000\000\006/"
  "\000\000\015/\000\0001/\000\000P/\000\000x/\000\000\227/\000\000\267/\000\000\324/\000\000\0020\000\000&0\000\000>0"
  "\000\000k0\000\000\2120\000\000\2420\000\000\3200\000\000\3570\000\000\t1\000\000\n1\000\00061\000\00071\000\000X1"
  "\000\000e1\000\000g1\000\000s1\000\000\2051\000\000\2411\000\000\2521\000\000\2611\000\000\3151\000\000\3161\000\000"
  "\3251\000\000\3631\000\000\3651\000\000\3661\000\000\3671\000\000\0342\000\000\0372\000\000&2\000\000F2\000\000G2\000"
  "\000J2\000\000Q2\000\000o2\000\000p2\000\000w2\000\000\2272\000\000\2302\000\000\2372\000\000\3112\000\000\3342\000"
  "\000\3422\000\000\0023\000\000\0273\000\000A3\000\000U3\000\000h3\000\000\2223\000\000\2463\000\000\2713\000\000\3433"
  "\000\000\3673\000\000\n4\000\000\0314\000\00054\000\000=4\000\000D4\000\000`4\000\000g4\000\000\2124\000\000\2234\000"
  "\000\2324\000\000\3004\000\000\3224\000\000\3354\000\000\3714\000\000\3744\000\000\0035\000\000\0375\000\000'5\000"
  "\000.5\000\000J5\000\000O5\000\000V5\000\000r5\000\000s5\000\000v5\000\000}5\000\000~5\000\000\3075\000\000\3325\000"
  "\000\3535\000\000\3545\000\000\n6\000\000\0236\000\000\0326\000\00086\000\000@6\000\000G6\000\000H6\000\000f6\000\000"
  "g6\000\000n6\000\000\2146\000\000\2256\000\000\2346\000\000\2356\000\000\2736\000\000\3166\000\000\3706\000\000\0147"
  "\000\000\0377\000\000M7\000\000c7\000\000x7\000\000\2467\000\000\2747\000\000\3217\000\000\3347\000\000\3437\000\000"
  "\3577\000\000\0008\000\000\0108\000\000\0238\000\00068\000\000f8\000\000m8\000\000o8\000\000\2278\000\000\2558\000"
  "\000\2638\000\000\3058\000\000\3138\000\000\3248\000\000\3338\000\000\3478\000\000\3718\000\000\3728\000\000\3738\000"
  "\000\0039\000\000\0179\000\000\0339\000\000H9\000\000I9\000\000J9\000\000`9\000\000\2149\000\000\2509\000\000\2529"
  "\000\000#:\000\000\212:\000\000\271:\000\000\025;\000\000z;\000\000\023<\000\000s<\000\000\321<\000\0004=\000\000\250"
  "=\000\000\327=\000\000\374=\000\000\037>\000\000D>\000\000q>\000\000\317>\000\000\355>\000\000\361>\000\000\367>\000"
  "\000\371>\000\000\372>\000\000\000\?\000\000\002\?\000\000\003\?\000\000X\?\000\000\300\?\000\000\336\?\000\000\342\?"
  "\000\000\350\?\000\000\352\?\000\000\353\?\000\000\361\?\000\000\363\?\000\000\364\?\000\000I@\000\000\252@\000\000"
  "\310@\000\000\314@\000\000\322@\000\000\324@\000\000\325@\000\000\333@\000\000\335@\000\000\336@\000\000/A\000\000kA"
  "\000\000fD\000\000\225D\000\000\205E\000\000\n\n\n<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\" \"http:/"
  "/www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">\n\n\n\n<script type=\"text/javascript\" src=\"js/live/createHtml.js\">"
  "</script>\n<script>\nfunction addErrorIcon(s, numErrors, durationDeviation, duration, numTsFiles) {\n  if (numErrors "
  "<= -100) return\n  s.a += '<div class=\"recording_errors\"><img class=\"icon\" src=\"'\n  if (durationDeviation > 300"
  " || numErrors  > 0) s.a += 'RecordingErrors.png'\n  else if (durationDeviation > 60) s.a += 'NotCheckedForRecordingEr"
  "rors.png'\n  else {\n    if (numErrors == 0) s.a += 'NoRecordingErrors.png'\n    if (numErrors  > 0) s.a += 'Recordin"
  "gErrors.png'\n    if (numErrors  < 0) s.a += 'NotCheckedForRecordingErrors.png'\n  }\n  s.a += '\" width = \"16px\" t"
  "itle=\"'\n  if (numErrors == 0) s.a += ''\n  if (numErrors  > 0) s.a += ' ' + String(numErrors)\n  if (numErrors  < 0"
  ") s.a += ''\n  s.a += ''\n  s.a += ''\n  s.a += ': '\n  addTime(s, durationDeviation)\n  s.a += ' '\n  s.a += ''\n  s"
  ".a += ''\n  s.a += ''\n  s.a += ': '\n  s.a += duration\n  s.a += ' '\n  s.a += ''\n  s.a += ''\n  s.a += ''\n  s.a +"
  "= ': '\n  s.a += String(numTsFiles)\n  s.a += '\" /> </div>'\n}\n\nfunction addHdSdIcon(s, hdsd, toolTip, frameParams"
  ") {\n  s.a += '<div class=\"recording_sd_hd\"><img class=\"icon\" src=\"'\n  s.a += hdsd\n  s.a += '.png\" width = \""
  "25px\" title=\"'\n  if (frameParams.length != 0) {\n    s.a += frameParams\n    s.a += ''\n  }\n  s.a += toolTip\n  s"
  ".a += '\" /></div>'\n}\n\nfunction IMDBS(s, im_db, name) {\n  if (im_db.length == 0) {\n    s.a += '<a href=\"http://"
  "www.imdb.com/find\?s=all&q='\n    if (name.startsWith(\"%\") ) {\n      s.a += name.substr(1)\n    } else {\n      s."
  "a += name\n    }\n  } else {\n    s.a += '<a href=\"https://www.imdb.com/title/'\n    s.a += im_db\n  }\n  s.a += \n "
  "  '\" target=\"_blank\"><img class=\"icon\" src=\"imdb.png\" title=\"\"/></a>'\n}\n\n\nfunction addEvent(s, bottomrow"
  "_i, obj) {\n// first column, timer /red or green, ...\n  let bottomrow = ''\n  if (bottomrow_i != 0) bottomrow = 'bot"
  "tomrow'\n  s.a += `<tr><td class=\"action leftcol ${bottomrow}\">`\n  if (obj[1].length != 0) {\n    s.a += '<a href="
  "\"edit_timer.html\?timerid=timer_'\n    s.a += obj[1]\n    s.a += '\"><img class=\"icon\" src=\"\" title=\"\" />'\n  "
  "} else {\n    s.a += '<a href=\"edit_timer.html\?epgid=event_'\n    s.a += obj[0]\n    s.a += '\"><img class=\"icon\""
  " src=\"\" title=\"\" />'\n  }\n  s.a += '</a>'\n  s.a += '<a href=\"searchresults.html\?searchplain='\n  s.a += obj[1"
  "1]\n  s.a += '\"><img class=\"icon\" src=\"\" title=\"\"/></a>'\n  IMDBS(s, obj[2], obj[11])\n  s.a += '</td>'\n// se"
  "cond col, dependent on width: channel\n  if (obj[9] > 0) {\n    s.a += `<td class=\"td-hidden-xs ${bottomrow}\"><div "
  "class=\"hidden-xs withmargin\"><a href=\"schedule.html\?channel=`\n    s.a += obj[9]\n    s.a += '\">'\n    s.a += ob"
  "j[10]\n    s.a += '</a></div></td>'\n  }\n// third col: image\n    s.a += `<td class=\"enlarge-image ${bottomrow}\">`"
  "\n    addScraperImageTitle(s, obj[3], obj[4], obj[5], obj[6], obj[7], obj[8], '');\n    s.a += '</td>'\n  s.a += `<td"
  " class=\"td-hidden-xs ${bottomrow}\"><div class=\"hidden-xs withmargin\">`\n  s.a += obj[14]\n  s.a += '</div></td>'"
  "\n// col with times, channel, name, short text\n  s.a += `<td class=\"rightcol ${bottomrow}\"><div class=\"withmargin"
  "\">`\n// first line: link to channel, times, channel\n  s.a += '<div class=\"margin-bottom display-xs\">'\n  if (obj["
  "9] > 0) {\n    s.a += '<a href=\"schedule.html\?channel='\n    s.a += obj[9]\n    s.a += '\">'\n  }\n  s.a += '<span "
  "class=\"normal-font\">'\n  s.a += obj[14]\n  if (obj[9] > 0) {\n    s.a += ' '\n    s.a += obj[10]\n  }\n  s.a += '</"
  "span>'\n  if (obj[9] > 0) s.a += '</a>'\n  s.a += '</div>'\n// sec&third line: Link to event, event title, short text"
  "\n  addEventRec(s, 'event_', obj[0], obj[11], '', obj[12], obj[13], '', '', '', '', '', 1)\n  s.a += '</div></td></tr"
  ">'\n}\nfunction eventString(bottomrow, data) {\n  const s = Object.create(null)\n  s.a = \"\"\n  addEvent(s, bottomro"
  "w, data)\n  return s.a\n}\n\n// existing recording\nfunction existingRecordingSR(s, col_span1, bottomrow, imdb_id, id"
  ", archiveDescr, image, pt, s_title, s_season_episode, s_runtime, s_date, day_time_duration, errors, hd_sd, channel_na"
  "me, newR, name, short_text, description, durationDeviation, folder, duration, numTsFiles) {\n  if (archiveDescr.lengt"
  "h != 0) col_span1--;\n  s.a += '<tr><td colspan='\n  s.a += col_span1.toString()\n  s.a += ' class=\"leftcol '\n  s.a"
  " += bottomrow\n  s.a += '\">'\n  if (archiveDescr.length != 0) {\n    s.a += '</td><td class=\"action '\n    s.a += b"
  "ottomrow\n    s.a += '\"> <img class=\"icon\" src=\"\" alt=\"on dvd\" title=\" />'\n    s.a += archiveDescr\n    s.a "
  "+= '/>'\n  } else {\n    s.a += '<br/><table><tr><td class=\"noborder\">'\n    addErrorIcon(s, errors, durationDeviat"
  "ion, duration, numTsFiles)\n    s.a += '</td><td class=\"noborder\">'\n    addHdSdIcon(s, hd_sd, channel_name, \"\")"
  "\n    s.a += '</td></tr></table>'\n  }\n  s.a += '</td><td class=\"td-hidden-xs '\n  s.a += bottomrow\n  s.a += '\"><"
  "div class=\"hidden-xs recording_day\">'\n  s.a += day_time_duration\n  s.a += '</div></td><td class=\"rightcol '\n  s"
  ".a += bottomrow\n  s.a += '\">'\n  addColEventRec(s, day_time_duration, 'recording_', id, name, folder, short_text, d"
  "escription, '', '')\n  s.a += '</td></tr>'\n}\nfunction existingRecordingString(col_span, bottomrow, id, archiveDescr"
  ", imdb_id, image, pt, s_title, s_season_episode, s_runtime, s_date, day_time_duration, errors, hd_sd, channel_name, n"
  "ewR, name, short_text, description, durationDeviation, folder, duration, size, numTsFiles) {\n  const s = Object.crea"
  "te(null)\n  s.a = \"\"\n  existingRecordingSR(s, col_span, bottomrow, imdb_id, id, archiveDescr, image, pt, s_title, "
  "s_season_episode, s_runtime, s_date, day_time_duration, errors, hd_sd, channel_name, newR, name, short_text, descript"
  "ion, durationDeviation, folder, duration, numTsFiles)\n  return s.a\n}\n\n\n</script>\n\n\n<link rel=\"stylesheet\" t"
  "ype=\"text/css\" href=\"css/styles.css\"/>\n<link rel=\"stylesheet\" type=\"text/css\" href=\"\"/>\n<link rel=\"style"
  "sheet\" type=\"text/css\" href=\"css/siteprefs.css\"/>\n<script type=\"text/javascript\" src=\"js/live/header.js\"></"
  "script>\n<script type=\"text/javascript\" src=\"js/live/epg_tt_box.js\"></script>\n\n\n\n<!-- start of fixed page hea"
  "der -->\n<div id=\"header\" style=\"width: 100%; background-color: inherit\">\n<div id=\"padding\" style=\"display: n"
  "one\"></div>\n<div id=\"content\">\n<!-- header content follows -->\n<div class=\"page_header\">\n<a href=\"\">\n<img"
  " src=\"\" alt=\"VDR Live!\" class=\"logo\" /></a>\n</div>\n<div style=\"clear: both\"></div>\n\n\n\nstyle=\"visibilit"
  "y: hidden\"\n\n\n<div class=\"\"><div class=\"__elapsed\" id=\"\" style=\"width: %\"></div></div>\n\n\n\n<a id=\"\"  "
  "href=\"vdr_request/\?param=\"  ><img src=\"\" alt=\"\" /></a> \n\n\n<a href=\"http://www.imdb.com/find\?s=all&q=\"\n<"
  "a href=\"http://www.imdb.com/title/\"\n target=\"_blank\"><img src=\"\" alt=\"\"  /></a> \n\n\n<a href=\"stream.html"
  "\?channelid_str=\"><img src=\"\" alt=\"\"  /></a>\n\n\n\n<a href=\"playlist.m3u\?channel_str=\"><img src=\"\" alt=\""
  "\"  /></a>\n\n\n\n<a href=\"\" download><img src=\"\" alt=\"\"  /> </a>\n\n\n\n\n<a href=\"http://localhost:/.ts\"><i"
  "mg src=\"\" alt=\"\"  /> </a>\n\n\n\n\t\t\n\t\t<a href=\"edit_timer.html\?epgid=\"><img src=\"\" alt=\"\"  /></a>\n\n"
  "\n\n\t<a href=\"edit_timer.html\?timerid=\"><img src=\"\" alt=\"\"  /></a>\n\n\n\n\n\t<script type=\"text/javascript"
  "\" src=\"js/mootools/mootools.v1.11.js\"></script>\n\t<script type=\"text/javascript\" src=\"js/live/liveajax.js\"></"
  "script>\n\t<script type=\"text/javascript\" src=\"js/live/infowin.js\"></script>\n\t<script type=\"text/javascript\" "
  "src=\"js/live/hinttips.js\"></script>\n\t<script type=\"text/javascript\" src=\"js/live/browserwin.js\"></script>\n\t"
  "<script type=\"text/javascript\" src=\"js/live/pageenhance.js\"></script>\n\t<script type=\"text/javascript\"><!--\n"
  "\t\tvar liveEnhanced = new PageEnhance({\n\t\t\t\tinfoWinOptions: {\n\t\t\t\t\tbuttonimg: 'img/transparent.png',\n\t"
  "\t\t\t\tloadingMsg: '',\n\t\t\t\t\terrorMsg: ''\n\t\t\t\t},\n\t\t\t\tnotifyStrings: {\n\t\t\t\t\tsuccessMsg: '<img sr"
  "c=\"\" alt=\"\"> ',\n\t\t\t\t\terrorMsg: '<img src=\"\" alt=\"\"> '\n\t\t\t\t}\n\t\t\t});\n\t--></script>\n\t<script "
  "type=\"text/javascript\" src=\"js/live/vdr_status.js\"></script>\n\t<script type=\"text/javascript\"><!--\n\t\tvar In"
  "foBox = new LiveVdrInfo('ibox.xml', 'infobox');\n\t\twindow.addEvent('domready', function(){\n\t\t\tInfoBox.request()"
  ";\n\t\t});\n\t\twindow.addEvent('unload', function(){\n\t\t\tInfoBox.pageFinished();\n\t\t});\n\t--></script>\n\n\n\n"
  "<div id=\"infobox\">\n\t<div class=\"statuscontent\">\n\t\t<div class=\"st_header\">\n\t\t\t<div id=\"infobox_caption"
  "\" class=\"caption\"></div>\n\t\t\t<div id=\"infobox_timenow\" class=\"now\">--:--</div>\n\t\t</div>\n\t\t<div class="
  "\"st_content\">\n\t\t\t<div id=\"infobox_name\" class=\"name\"></div>\n\t\t\t<div id=\"infobox_duration\" class=\"dur"
  "ation\">--:--</div>\n\t\t</div>\n\t\t<div class=\"st_controls\">\n\t\t\t<div class=\"st_update\">\n\t\t\t\t<a href=\""
  "javascript:InfoBox.toggleUpdate()\" ><img id=\"statusReloadBtn\" src=\"\" alt=\"\" /></a>\n\t\t\t</div>\n\t\t\t<div i"
  "d=\"infobox_recording_buttons\" style=\"display: none\">\n\t\t\t\t\n\t\t\t\t\n\t\t\t\t\n\t\t\t\t\n\t\t\t\t\n\t\t\t</d"
  "iv>\n\t\t\t<div id=\"infobox_channel_buttons\">\n\t\t\t\t\n\t\t\t\t\n\t\t\t</div>\n\t\t\t<div class=\"st_pbar\">\n\t"
  "\t\t\t\n\t\t\t</div>\n\t\t</div>\n\t</div>\n\t<div style=\"display: none;\">\n\t\t<span id=\"__infobox_request_err\">"
  "</span>\n\t\t<span id=\"__infobox_update_err\"></span>\n\t</div>\n</div>\n\n\n\n\t\n\t  \n\t<a href=\"searchresults.h"
  "tml\?searchplain=\"><img src=\"\" alt=\"\"  /></a>\n\t\n\t\n\t\t\n<img data-src=\"img/transparent.png\" height=\"10px"
  "\" />\n<span id=\"icons-\"></span>\n\t\t\t\t\t<script class=\"injectIcons\">\n\t\t\t\t\tinjectHdSdIcon(\"icons-\", \""
  "\", \"\", \"\")\n\t\t\t\t\t</script>\n\t\t<td class=\"action leftcol \"></td>\n\t\t<td class=\"action \"></td>\n\t\t"
  "\t\t<td class=\"action \">\n\t\t\t\t\t\t<a href=\"searchresults.html\?searchplain=\"><img src=\"\" alt=\"\"  /></a></"
  "td>\n\t\t\t\t<td class=\"action \"></td>\n\t\t\t\t<td class=\"action \"></td>\n\t\t\t\t<td class=\"action \">\n\t\t\t"
  "\n\t\t</td>\n\n\n\n\t<div class=\"epg_description\" id=\"\">\n\t\t<div class=\"station\">\n\t\t\t<div class=\"boxhead"
  "er\">\n\n<div>\n<div class = \"caption\">\n  <a id=\"_epg_m\"     class = \"active\"   onclick=\"displayEPG('')\" ></"
  "a>\n| <a id=\"_scraper_m\" class = \"inactive\" onclick=\"displayScraper('')\"></a>\n| <a id=\"_actors_m\"  class = "
  "\"inactive\" onclick=\"displayActors('')\" ></a>\n| <a id=\"_artwork_m\" class = \"inactive\" onclick=\"displayArtwor"
  "k('')\" ></a>\n</div>\n<div class=\"caption\"></div>\n</div>\n                        </div>\n\t\t</div>\n\t\t<div cl"
  "ass=\"epg_content\">\n\t\t\t<div class=\"epg_tools\">\n\t\t\t\t\n\t\t\t</div>\n\t\t\t<div class=\"epg_info\">\n\t\t\t"
  "\t<div class=\"info\">\n\t\t\t\t\t<div class=\"duration\">\n\t\t\t\t\t\t<span title=\"\"></span> / <span title=\"\"><"
  "/span>\n\t\t\t\t\t\t<div class=\"progress\"><div></div></div>\n\t\t\t\t\t</div>\n\t\t\t\t\t<div class=\"time\">\n    "
  "          <span class=\"bold\"></span>\n            \n              <div class=\"channel\"></div>\n\t\t\t\t\t</div>\n"
  "\t\t\t\t\t<div class=\"title\"></div>\n\t\t\t\t\t<div class=\"short\"></div>\n\t\t\t\t\t<div class=\"description\" id"
  "=_description>\n\t\t\t\t\t<span id = \"_epg_image\" class=\"epg_images\">\n         <a href=\"/epgimages/\" target=\""
  "_blank\">\n\t\t\t\t\t\t<img src=\"/epgimages/\" class=\"epg_image\"/>\n         </a>\n    <a href=\"/tvscraper/\" tar"
  "get=\"_blank\">\n\t    <img src=\"/tvscraper/\" class=\"epg_image\"/>\n    </a>\n    <a href=\"/tvscraper/\" target="
  "\"_blank\">\n      <img src=\"/tvscraper/\" class=\"epg_image\"/>\n    </a>\n      <a href=\"/recimages//\" target=\""
  "_blank\">\n\t\t\t\t<img src=\"/recimages//\" class=\"epg_image\"/>\n      </a>\n\t\t\t\t\t</span> \n\n\n<div id = '_s"
  "craper' hidden>\n  <div class=\"scraper_list\">         </div>\n  <div class=\"scraper_list\"> </div>\n    <div class"
  "=\"scraper_list\"> SE </div>\n    <div class=\"scraper_list\">   </div>\n      <div class=\"scraper_list\">  / </div>"
  "\n    <div class=\"scraper_list\"> </div>\n      <div class=\"scraper_list\"> </div>\n      <a href=\"https://www.imd"
  "b.com/title/\" target=\"_blank\">  </a>\n      <div class=\"scraper_list\"></div>\n      <table>\n      <tr>\n       "
  " <td class=\"cast_role\">  </td>\n        <td>  </td>\n      </tr>\n      <tr>\n        <td class=\"cast_role\">  </t"
  "d>\n        <td>  </td>\n      </tr>\n      <tr>\n        <td class=\"cast_role\">  </td>\n        <td>  </td>\n     "
  " </tr>\n      </table>\n  <div class=\"scraper_list\">        </div>\n  <div class=\"scraper_list\">       </div>\n  "
  "<div class=\"scraper_list\">         </div>\n  <div class=\"scraper_list\"><a href =\"\" target=\"_blank\"></a></div>"
  "\n  <div class=\"scraper_list\">   </div>\n  <div class=\"scraper_list\">        </div>\n  <div class=\"scraper_list"
  "\">     </div>\n  <div class=\"scraper_list\">  / </div>\n\n    <div class=\"scraper_list\">\n      <a href=\"https:/"
  "/www.imdb.com/title/\" target=\"_blank\">  </a>\n    </div>\n\n    <div class=\"scraper_list\">         </div>\n    <"
  "div class=\"scraper_list\">        </div>\n\n    <div class=\"scraper_list\"> </div>\n    <div class=\"scraper_list\""
  ">         </div>\n\n    <div class=\"scraper_list\"></div>\n    <table>\n      <tr>\n        <td class=\"cast_role\">"
  "  </td>\n        <td>  </td>\n      </tr>\n        <tr>\n          <td class=\"cast_role\">  </td>\n          <td>  <"
  "/td>\n        </tr>\n        <tr>\n          <td class=\"cast_role\">  </td>\n          <td>  </td>\n        </tr>\n "
  " </table>\n</div>\n\n<div id = '_actors' hidden>\n<table>\n      <tr>\n    <td>\n      <a href=\"/tvscraper/\" target"
  "=\"_blank\">\n        <img src=\"/tvscraper/\" alt=\": \" class=\"actor\" />\n      </a>\n    </td>\n      </tr>\n   "
  "   <tr></tr>\n    </tr>\n    <tr></tr>\n</table>\n</div>\n\n<div id = '_artwork' hidden>\n\n\n\n</div>\n\n<div id = '"
  "_epg'>\n\t\t\t\t\t\t\t\t\t</div>\n\t\t\t</div>\n\t\t</div>\n\t</div>\n</div>\n\n\n  <a href=\"/tvscraper/\" target=\""
  "_blank\">\n    <img src=\"/tvscraper/\" class=\"artwork\" />\n  </a>\n\n\n\t<div class=\"epg_description\" id=\"about"
  "Box\">\n\t\t<div class=\"station\">\n\t\t\t<div class=\"boxheader\"><div><div class=\"caption\"></div></div></div>\n"
  "\t\t</div>\n\t\t<div class=\"epg_content\">\n\t\t\t<div>\n\t\t\t\t<div class=\"about_head\"><div><div></div></div></d"
  "iv>\n\t\t\t\t<div class=\"about_left\">:</div>\n\t\t\t\t<div class=\"about_right\">Thomas Keil (Thomas)</div>\n\t\t\t"
  "\t<div class=\"about_left\">:</div>\n\t\t\t\t<div class=\"about_right\">Sascha Volkenandt (LordJaxom)</div>\n\t\t\t\t"
  "<div class=\"about_left\">:</div>\n\t\t\t\t<div class=\"about_right\">Markus Ehrnsperger (MarkusE @ <a href=\"https:/"
  "/www.vdr-portal.de\">VDR Portal</a>)</div>\n\t\t\t\t<div class=\"about_left\">:</div>\n\t\t\t\t<div class=\"about_rig"
  "ht\">Jasmin Jessich (jasminj)</div>\n\t\t\t\t<div class=\"about_left\">:</div>\n\t\t\t\t<div class=\"about_right\">Di"
  "eter Hametner (tadi)</div>\n\t\t\t\t<div class=\"about_left\">:</div>\n\t\t\t\t<div class=\"about_right\">Christian W"
  "ieninger (winni)</div>\n\t\t\t\t<div class=\"about_left\">:</div>\n\t\t\t\t<div class=\"about_right\">Michael Br&uuml"
  ";ckner (skiller2k1)</div>\n\t\t\t\t<div class=\"about_head\"><div><div></div></div></div>\n\t\t\t\t<div class=\"about"
  "_left\">:</div>\n\t\t\t\t<div class=\"about_right\"></div>\n\t\t\t\t<div class=\"about_left\">:</div>\n\t\t\t\t<div c"
  "lass=\"about_right\"></div>\n\t\t\t\t<div class=\"about_head\"><div><div></div></div></div>\n\t\t\t\t<div class=\"abo"
  "ut_left\">EPGsearch:</div>\n\t\t\t\t<div class=\"about_right\">\n\t\t\t\t\t<img align=\"center\" src=\"\"/>\n\t\t\t\t"
  "\t\t: \n\t\t\t\t\t\t: \n\t\t\t\t\t(<a href=\"https://github.com/vdr-projects/vdr-plugin-epgsearch\" target=\"_blank\""
  "></a>)<br/>\n\t\t\t\t</div>\n\t\t\t\t<div class=\"about_left\">Streamdev server:</div>\n\t\t\t\t<div class=\"about_ri"
  "ght\">\n\t\t\t\t\t<img align=\"center\" src=\"\"/>\n\t\t\t\t\t\t: \n\t\t\t\t\t\t: \n\t\t\t\t\t(<a href=\"https://gith"
  "ub.com/vdr-projects/vdr-plugin-streamdev\" target=\"_blank\"></a>)<br/>\n\t\t\t\t</div>\n\t\t\t\t<div class=\"about_l"
  "eft\">tvscraper:</div>\n\t\t\t\t<div class=\"about_right\">\n\t\t\t\t\t<img align=\"center\" src=\"\"/>\n\t\t\t\t\t\t"
  ": \n\t\t\t\t\t\t: \n\t\t\t\t\t(<a href=\"https://github.com/MarkusEh/vdr-plugin-tvscraper\" target=\"_blank\"></a>)<b"
  "r/>\n\t\t\t\t</div>\n\t\t\t\t<div class=\"about_head\"><div><div></div></div></div>\n\t\t\t\t<div class=\"about_line"
  "\">Movie information provided by <a target=\"_blank\" href=\"https://www.themoviedb.org/\">TMDB</a>. This product use"
  "s the TMDB API but is not endorsed or certified by TMDB</div>\n\t\t\t\t<div class=\"about_line\">Information provided"
  " by TheTVDB.com. Please consider <a target=\"_blank\" href=\"https://u10505776.ct.sendgrid.net/ls/click\?upn=xMYYCP13"
  "hVd-2BZPpbVcMPHeLXfv-2BPRdIsKm2qSeirIHi7kH9am8IxD-2BavFbeqGqIXIcjH_INgc0CXRkIvGU-2BJ1W6HLAynNbR0UBoMb2tkpDdezO3QRj-2F"
  "QPQAMrtJKVcB0N7eSvbYpjQTDNOQBf2pb94uDgGr0-2BXyXFk7Oyfva30BASYCRLvtRQyi5eOCAbH8fon7UETlPydobeLA3Recu9OsXol8c7Ng4pDAsH6"
  "KsFF8CH7HQoVxivnpKrQW2v4ek7U-2BYlWmH31o9Koke3vq-2FDsQ0P-2BiKLECU3LgttsntUcN8fnUs-3D\">supporting them</a></div>\n\t\t"
  "\t\t<div class=\"about_head\"><div><div></div></div></div>\n\t\t\t\t<div class=\"about_line\">:<br/>\n\t\t\t\t\t<a ta"
  "rget=\"_blank\" href=\"https://github.com/MarkusEh/vdr-plugin-live/issues\">https://github.com/MarkusEh/vdr-plugin-li"
  "ve/issues</a></div>\n\t\t\t\t<div class=\"about_head\"><div><div>&nbsp;</div></div></div>\n\t\t\t</div>\n\t\t</div>\n"
  "\t</div>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    doc_type(*this, "doc_type"),
    create_html_js(*this, "create_html_js"),
    stylesheets(*this, "stylesheets"),
    logo(*this, "logo"),
    hide_element(*this, "hide_element"),
    progressbar(*this, "progressbar"),
    ajax_action_href(*this, "ajax_action_href"),
    imdb_info_href(*this, "imdb_info_href"),
    hls_channel(*this, "hls_channel"),
    m3u_playlist_channel(*this, "m3u_playlist_channel"),
    m3u_playlist_recording(*this, "m3u_playlist_recording"),
    stream_recording(*this, "stream_recording"),
    event_timer(*this, "event_timer"),
    edit_timer(*this, "edit_timer"),
    ajax_js(*this, "ajax_js"),
    infobox(*this, "infobox"),
    epg_tool_box(*this, "epg_tool_box"),
    epg_tt_box(*this, "epg_tt_box"),
    media(*this, "media"),
    about_tt_box(*this, "about_tt_box")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

#line 59 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[0]; // \n
  reply.out() << _tntChunks[1]; // \n\n
  reply.out() << _tntChunks[3]; // \n
  reply.out() << _tntChunks[4]; // \n\n
  reply.out() << _tntChunks[43]; // \n\n
  reply.out() << _tntChunks[46]; // \n
  reply.out() << _tntChunks[47]; // \n\n
  reply.out() << _tntChunks[54]; // \n
  reply.out() << _tntChunks[55]; // \n\n
  reply.out() << _tntChunks[57]; // \n
  reply.out() << _tntChunks[58]; // \n\n
  reply.out() << _tntChunks[65]; // \n
  reply.out() << _tntChunks[66]; // \n\n
  reply.out() << _tntChunks[77]; // \n
  reply.out() << _tntChunks[78]; // \n\n
  reply.out() << _tntChunks[86]; // \n
  reply.out() << _tntChunks[87]; // \n\n
  reply.out() << _tntChunks[92]; // \n
  reply.out() << _tntChunks[93]; // \n\n
  reply.out() << _tntChunks[98]; // \n
  reply.out() << _tntChunks[99]; // \n\n
  reply.out() << _tntChunks[105]; // \n
  reply.out() << _tntChunks[106]; // \n
  reply.out() << _tntChunks[107]; // \n\n
  reply.out() << _tntChunks[114]; // \n
  reply.out() << _tntChunks[115]; // \n\n
  reply.out() << _tntChunks[122]; // \n
  reply.out() << _tntChunks[123]; // \n\n
  reply.out() << _tntChunks[128]; // \n\n
  reply.out() << _tntChunks[129]; // \n\n
  reply.out() << _tntChunks[139]; // \n
  reply.out() << _tntChunks[140]; // \n\n
  reply.out() << _tntChunks[155]; // \n
  reply.out() << _tntChunks[156]; // \n\n
  reply.out() << _tntChunks[199]; // \n
  reply.out() << _tntChunks[200]; // \n\n
  reply.out() << _tntChunks[374]; // \n
  reply.out() << _tntChunks[375]; // \n
  reply.out() << _tntChunks[379]; // \n\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::doc_type_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::doc_type " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 59 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[2]; // <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::create_html_js_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::create_html_js " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 59 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 71 "pageelems.ecpp"

const char *lf = "<br/>";

  reply.out() << _tntChunks[5]; // <script type="text/javascript" src="js/live/createHtml.js"></script>\n<script>\nfunction addErrorIcon(s, numErrors, durationDeviation, duration, numTsFiles) {\n  if (numErrors <= -100) return\n  s.a += '<div class="recording_errors"><img class="icon" src="
#line 78 "pageelems.ecpp"
  reply.sout() << (LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[6]; // '\n  if (durationDeviation > 300 || numErrors  > 0) s.a += 'RecordingErrors.png'\n  else if (durationDeviation > 60) s.a += 'NotCheckedForRecordingErrors.png'\n  else {\n    if (numErrors == 0) s.a += 'NoRecordingErrors.png'\n    if (numErrors  > 0) s.a += 'RecordingErrors.png'\n    if (numErrors  < 0) s.a += 'NotCheckedForRecordingErrors.png'\n  }\n  s.a += '" width = "16px" title="'\n  if (numErrors == 0) s.a += '
#line 87 "pageelems.ecpp"
  reply.sout() << (tr("No recording errors"));
  reply.out() << _tntChunks[7]; // '\n  if (numErrors  > 0) s.a += '
#line 88 "pageelems.ecpp"
  reply.sout() << (tr("Number of recording errors:"));
  reply.out() << _tntChunks[8]; //  ' + String(numErrors)\n  if (numErrors  < 0) s.a += '
#line 89 "pageelems.ecpp"
  reply.sout() << (tr("Recording errors unknown"));
  reply.out() << _tntChunks[9]; // '\n  s.a += '
#line 90 "pageelems.ecpp"
  reply.out() << (lf);
  reply.out() << _tntChunks[10]; // '\n  s.a += '
#line 91 "pageelems.ecpp"
  reply.sout() << (tr("Duration deviation from event length"));
  reply.out() << _tntChunks[11]; // '\n  s.a += ': '\n  addTime(s, durationDeviation)\n  s.a += ' '\n  s.a += '
#line 95 "pageelems.ecpp"
  reply.sout() << (tr("min"));
  reply.out() << _tntChunks[12]; // '\n  s.a += '
#line 96 "pageelems.ecpp"
  reply.out() << (lf);
  reply.out() << _tntChunks[13]; // '\n  s.a += '
#line 97 "pageelems.ecpp"
  reply.sout() << (tr("Recording length"));
  reply.out() << _tntChunks[14]; // '\n  s.a += ': '\n  s.a += duration\n  s.a += ' '\n  s.a += '
#line 101 "pageelems.ecpp"
  reply.sout() << (tr("h"));
  reply.out() << _tntChunks[15]; // '\n  s.a += '
#line 102 "pageelems.ecpp"
  reply.out() << (lf);
  reply.out() << _tntChunks[16]; // '\n  s.a += '
#line 103 "pageelems.ecpp"
  reply.sout() << (tr("Number of ts files"));
  reply.out() << _tntChunks[17]; // '\n  s.a += ': '\n  s.a += String(numTsFiles)\n  s.a += '" /> </div>'\n}\n\nfunction addHdSdIcon(s, hdsd, toolTip, frameParams) {\n  s.a += '<div class="recording_sd_hd"><img class="icon" src="
#line 110 "pageelems.ecpp"
  reply.sout() << (LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[18]; // '\n  s.a += hdsd\n  s.a += '.png" width = "25px" title="'\n  if (frameParams.length != 0) {\n    s.a += frameParams\n    s.a += '
#line 115 "pageelems.ecpp"
  reply.out() << (lf);
  reply.out() << _tntChunks[19]; // '\n  }\n  s.a += toolTip\n  s.a += '" /></div>'\n}\n\nfunction IMDBS(s, im_db, name) {\n  if (im_db.length == 0) {\n    s.a += '<a href="http://www.imdb.com/find\?s=all&q='\n    if (name.startsWith("%") ) {\n      s.a += name.substr(1)\n    } else {\n      s.a += name\n    }\n  } else {\n    s.a += '<a href="https://www.imdb.com/title/'\n    s.a += im_db\n  }\n  s.a += \n   '" target="_blank"><img class="icon" src="
#line 134 "pageelems.ecpp"
  reply.sout() << (LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[20]; // imdb.png" title="
#line 134 "pageelems.ecpp"
  reply.sout() << (tr("Find more at the Internet Movie Database."));
  reply.out() << _tntChunks[21]; // "/></a>'\n}\n\n
  reply.out() << _tntChunks[22]; // \nfunction addEvent(s, bottomrow_i, obj) {\n// first column, timer /red or green, ...\n  let bottomrow = ''\n  if (bottomrow_i != 0) bottomrow = 'bottomrow'\n  s.a += `<tr><td class="action leftcol ${bottomrow}">`\n  if (obj[1].length != 0) {\n    s.a += '<a href="edit_timer.html\?timerid=timer_'\n    s.a += obj[1]\n    s.a += '"><img class="icon" src="
#line 163 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "record_timer.png") );
  reply.out() << _tntChunks[23]; // " title="
#line 163 "pageelems.ecpp"
  reply.sout() << (tr("Edit timer"));
  reply.out() << _tntChunks[24]; // " />'\n  } else {\n    s.a += '<a href="edit_timer.html\?epgid=event_'\n    s.a += obj[0]\n    s.a += '"><img class="icon" src="
#line 167 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "record.png") );
  reply.out() << _tntChunks[25]; // " title="
#line 167 "pageelems.ecpp"
  reply.sout() << (tr("Record this"));
  reply.out() << _tntChunks[26]; // " />'\n  }\n  s.a += '</a>'\n
#line 170 "pageelems.ecpp"
if (LiveFeatures<features::epgsearch>().Recent() ) { 
  reply.out() << _tntChunks[27]; //   s.a += '<a href="searchresults.html\?searchplain='\n  s.a += obj[11]\n  s.a += '"><img class="icon" src="
#line 173 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "search.png") );
  reply.out() << _tntChunks[28]; // " title="
#line 173 "pageelems.ecpp"
  reply.sout() << (tr("Search for repeats."));
  reply.out() << _tntChunks[29]; // "/></a>'\n
#line 174 "pageelems.ecpp"
 } if (LiveSetup().GetShowIMDb() ) { 
  reply.out() << _tntChunks[30]; //   IMDBS(s, obj[2], obj[11])\n
#line 176 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[31]; //   s.a += '</td>'\n// second col, dependent on width: channel\n  if (obj[9] > 0) {\n    s.a += `<td class="td-hidden-xs ${bottomrow}"><div class="hidden-xs withmargin"><a href="schedule.html\?channel=`\n    s.a += obj[9]\n    s.a += '">'\n    s.a += obj[10]\n    s.a += '</a></div></td>'\n  }\n// third col: image\n
#line 187 "pageelems.ecpp"
 if (!LiveSetup().GetTvscraperImageDir().empty() ) { 
  reply.out() << _tntChunks[32]; //     s.a += `<td class="enlarge-image ${bottomrow}">`\n    addScraperImageTitle(s, obj[3], obj[4], obj[5], obj[6], obj[7], obj[8], '
#line 189 "pageelems.ecpp"
  reply.out() << (lf);
  reply.out() << _tntChunks[33]; // ');\n    s.a += '</td>'\n
#line 191 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[34]; //   s.a += `<td class="td-hidden-xs ${bottomrow}"><div class="hidden-xs withmargin">`\n  s.a += obj[14]\n  s.a += '</div></td>'\n// col with times, channel, name, short text\n  s.a += `<td class="rightcol ${bottomrow}"><div class="withmargin">`\n// first line: link to channel, times, channel\n  s.a += '<div class="margin-bottom display-xs">'\n  if (obj[9] > 0) {\n    s.a += '<a href="schedule.html\?channel='\n    s.a += obj[9]\n    s.a += '">'\n  }\n  s.a += '<span class="normal-font">'\n  s.a += obj[14]\n  if (obj[9] > 0) {\n    s.a += ' '\n    s.a += obj[10]\n  }\n  s.a += '</span>'\n  if (obj[9] > 0) s.a += '</a>'\n  s.a += '</div>'\n// sec&third line: Link to event, event title, short text\n  addEventRec(s, 'event_', obj[0], obj[11], '', obj[12], obj[13], '
#line 214 "pageelems.ecpp"
  reply.out() << (lf);
  reply.out() << _tntChunks[35]; // ', '
#line 214 "pageelems.ecpp"
  reply.sout() << (tr("Click to view details."));
  reply.out() << _tntChunks[36]; // ', '', '', '', 1)\n  s.a += '</div></td></tr>'\n}\nfunction eventString(bottomrow, data) {\n  const s = Object.create(null)\n  s.a = ""\n  addEvent(s, bottomrow, data)\n  return s.a\n}\n\n// existing recording\nfunction existingRecordingSR(s, col_span1, bottomrow, imdb_id, id, archiveDescr, image, pt, s_title, s_season_episode, s_runtime, s_date, day_time_duration, errors, hd_sd, channel_name, newR, name, short_text, description, durationDeviation, folder, duration, numTsFiles) {\n  if (archiveDescr.length != 0) col_span1--;\n  s.a += '<tr><td colspan='\n  s.a += col_span1.toString()\n  s.a += ' class="leftcol '\n  s.a += bottomrow\n  s.a += '">
#line 231 "pageelems.ecpp"
  reply.sout() << ( tr("Existing Recording:") );
  reply.out() << _tntChunks[37]; // '\n  if (archiveDescr.length != 0) {\n    s.a += '</td><td class="action '\n    s.a += bottomrow\n    s.a += '"> <img class="icon" src="
#line 235 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "on_dvd.png") );
  reply.out() << _tntChunks[38]; // " alt="on dvd" title=" />'\n    s.a += archiveDescr\n    s.a += '/>'\n
#line 238 "pageelems.ecpp"

#if VDRVERSNUM >= 20505

  reply.out() << _tntChunks[39]; //   } else {\n    s.a += '<br/><table><tr><td class="noborder">'\n    addErrorIcon(s, errors, durationDeviation, duration, numTsFiles)\n    s.a += '</td><td class="noborder">'\n    addHdSdIcon(s, hd_sd, channel_name, "")\n    s.a += '</td></tr></table>'\n
#line 247 "pageelems.ecpp"

#endif

  reply.out() << _tntChunks[40]; //   }\n  s.a += '</td><td class="td-hidden-xs '\n  s.a += bottomrow\n  s.a += '"><div class="hidden-xs recording_day">'\n  s.a += day_time_duration\n  s.a += '</div></td><td class="rightcol '\n  s.a += bottomrow\n  s.a += '">'\n  addColEventRec(s, day_time_duration, 'recording_', id, name, folder, short_text, description, '
#line 258 "pageelems.ecpp"
  reply.out() << (lf);
  reply.out() << _tntChunks[41]; // ', '
#line 258 "pageelems.ecpp"
  reply.sout() << (tr("Click to view details."));
  reply.out() << _tntChunks[42]; // ')\n  s.a += '</td></tr>'\n}\nfunction existingRecordingString(col_span, bottomrow, id, archiveDescr, imdb_id, image, pt, s_title, s_season_episode, s_runtime, s_date, day_time_duration, errors, hd_sd, channel_name, newR, name, short_text, description, durationDeviation, folder, duration, size, numTsFiles) {\n  const s = Object.create(null)\n  s.a = ""\n  existingRecordingSR(s, col_span, bottomrow, imdb_id, id, archiveDescr, image, pt, s_title, s_season_episode, s_runtime, s_date, day_time_duration, errors, hd_sd, channel_name, newR, name, short_text, description, durationDeviation, folder, duration, numTsFiles)\n  return s.a\n}\n\n\n</script>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::stylesheets_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::stylesheets " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 59 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[44]; // <link rel="stylesheet" type="text/css" href="css/styles.css"/>\n<link rel="stylesheet" type="text/css" href="
#line 275 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("css", "theme.css") );
  reply.out() << _tntChunks[45]; // "/>\n<link rel="stylesheet" type="text/css" href="css/siteprefs.css"/>\n<script type="text/javascript" src="js/live/header.js"></script>\n<script type="text/javascript" src="js/live/epg_tt_box.js"></script>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::logo_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::logo " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 59 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[48]; // <!-- start of fixed page header -->\n<div id="header" style="width: 100%; background-color: inherit">\n<div id="padding" style="display: none"></div>\n<div id="content">\n<!-- header content follows -->\n
#line 289 "pageelems.ecpp"

	if (LiveSetup().GetShowLogo() || LiveSetup().GetShowInfoBox()) {

  reply.out() << _tntChunks[49]; // <div class="page_header">\n
#line 293 "pageelems.ecpp"

		if (LiveSetup().GetShowLogo()) {

  reply.out() << _tntChunks[50]; // <a href="
#line 296 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetStartScreenLink());
  reply.out() << _tntChunks[51]; // ">\n<img src="
#line 297 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "logo.png") );
  reply.out() << _tntChunks[52]; // " alt="VDR Live!" class="logo" /></a>\n
#line 298 "pageelems.ecpp"

		}

#line 301 "pageelems.ecpp"
if (LiveSetup().GetShowInfoBox()) { 
  // <& infobox ...
  { 
#line 301 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 301 "pageelems.ecpp"
  main().infobox(request, reply, _tnt_cq0);
    // &>
  }
#line 301 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[53]; // </div>\n<div style="clear: both"></div>\n
#line 304 "pageelems.ecpp"

	}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::hide_element_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::hide_element " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
int hide = qparam.get< int >("hide", ( 1));
  // </%args>

#line 59 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 315 "pageelems.ecpp"
 if (hide) { 
  reply.out() << _tntChunks[56]; // style="visibility: hidden"
#line 315 "pageelems.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::progressbar_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::progressbar " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
int progress = qparam.get< int >("progress", ( 0));
std::string id = qparam.get< std::string >("id");
int duration = qparam.get< int >("duration", ( -1));
  // </%args>

#line 59 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 326 "pageelems.ecpp"

	std::string cls("__progress");
	if ((duration >= 0) && ((progress < 0) || (duration == 0)))
		cls +="_invisible";

  reply.out() << _tntChunks[59]; // <div class="
#line 331 "pageelems.ecpp"
  reply.sout() << ( cls );
  reply.out() << _tntChunks[60]; // "><div class="__elapsed" 
#line 331 "pageelems.ecpp"
 if (!id.empty()) { 
  reply.out() << _tntChunks[61]; // id="
#line 331 "pageelems.ecpp"
  reply.sout() << ( id );
  reply.out() << _tntChunks[62]; // " 
#line 331 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[63]; // style="width: 
#line 331 "pageelems.ecpp"
  reply.sout() << ( progress );
  reply.out() << _tntChunks[64]; // %"></div></div>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::ajax_action_href_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::ajax_action_href " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string action = qparam.get< std::string >("action");
std::string tip = qparam.get< std::string >("tip");
std::string param = qparam.get< std::string >("param");
std::string image = qparam.get< std::string >("image");
std::string alt = qparam.get< std::string >("alt");
std::string id = qparam.get< std::string >("id");
  // </%args>

#line 59 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 345 "pageelems.ecpp"
 { 
  reply.out() << _tntChunks[67]; // <a 
#line 345 "pageelems.ecpp"
 if (!id.empty()) { 
  reply.out() << _tntChunks[68]; // id="
#line 345 "pageelems.ecpp"
  reply.sout() << ( id );
  reply.out() << _tntChunks[69]; // " 
#line 345 "pageelems.ecpp"
 } 
  // <& hide_element ...
  { 
#line 345 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 345 "pageelems.ecpp"
    _tnt_cq1.add( "hide", (id.empty()? 0 : 1));
#line 345 "pageelems.ecpp"
  main().hide_element(request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[70]; //  href="vdr_request/
#line 345 "pageelems.ecpp"
  reply.sout() << ( action );
  reply.out() << _tntChunks[71]; // \?param=
#line 345 "pageelems.ecpp"
  reply.sout() << ( param );
  reply.out() << _tntChunks[72]; // " 
#line 345 "pageelems.ecpp"
if (!tip.empty()) { 
  // <& tooltip.hint ...
  { 
#line 345 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 345 "pageelems.ecpp"
    _tnt_cq2.add( "text", (tip));
#line 345 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[73]; //  
#line 345 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[74]; // ><img src="
#line 345 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", image) );
  reply.out() << _tntChunks[75]; // " alt="
#line 345 "pageelems.ecpp"
  reply.sout() << ( alt );
  reply.out() << _tntChunks[76]; // " /></a> 
#line 345 "pageelems.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::imdb_info_href_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::imdb_info_href " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string title = qparam.get< std::string >("title");
std::string s_IMDB_ID = qparam.get< std::string >("s_IMDB_ID");
  // </%args>

#line 59 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 355 "pageelems.ecpp"

// if (LiveSetup().GetShowIMDb())
{
if (s_IMDB_ID.empty() ) { 
  reply.out() << _tntChunks[79]; // <a href="http://www.imdb.com/find\?s=all&q=
#line 359 "pageelems.ecpp"
  reply.sout() << ( (!title.empty() && title[0] == '%')?StringUrlEncode(cSv(title).substr(1)):StringUrlEncode(title) );
  reply.out() << _tntChunks[80]; // "\n
#line 360 "pageelems.ecpp"
 } else { 
  reply.out() << _tntChunks[81]; // <a href="http://www.imdb.com/title/
#line 361 "pageelems.ecpp"
  reply.sout() << ( s_IMDB_ID );
  reply.out() << _tntChunks[82]; // "\n
#line 362 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[83]; //  target="_blank"><img src="
#line 363 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "imdb.png") );
  reply.out() << _tntChunks[84]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 363 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 363 "pageelems.ecpp"
    _tnt_cq3.add( "text", (tr("Find more at the Internet Movie Database.")));
#line 363 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[85]; //  /></a> 
#line 363 "pageelems.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::hls_channel_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::hls_channel " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string channelId = qparam.get< std::string >("channelId");
  // </%args>

#line 59 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 372 "pageelems.ecpp"

if (LiveSetup().GetUseStreamdev() && LiveFeatures<features::streamdev_server>().Loaded()) {

  reply.out() << _tntChunks[88]; // <a href="stream.html\?channelid_str=
#line 375 "pageelems.ecpp"
  reply.sout() << ( channelId );
  reply.out() << _tntChunks[89]; // "><img src="
#line 375 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "stream_button.png") );
  reply.out() << _tntChunks[90]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 375 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 375 "pageelems.ecpp"
    _tnt_cq4.add( "text", (tr("Stream this channel into browser.")));
#line 375 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[91]; //  /></a>\n
#line 376 "pageelems.ecpp"

}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::m3u_playlist_channel_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::m3u_playlist_channel " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string channelId = qparam.get< std::string >("channelId");
  // </%args>

#line 59 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 387 "pageelems.ecpp"

if (LiveSetup().GetUseStreamdev() && LiveFeatures<features::streamdev_server>().Loaded()) {

  reply.out() << _tntChunks[94]; // <a href="playlist.m3u\?channel_str=
#line 390 "pageelems.ecpp"
  reply.sout() << ( channelId );
  reply.out() << _tntChunks[95]; // "><img src="
#line 390 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "playlist.png") );
  reply.out() << _tntChunks[96]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 390 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 390 "pageelems.ecpp"
    _tnt_cq5.add( "text", (tr("Stream this channel into media player.")));
#line 390 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << _tntChunks[97]; //  /></a>\n
#line 391 "pageelems.ecpp"

}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::m3u_playlist_recording_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::m3u_playlist_recording " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string recid = qparam.get< std::string >("recid");
std::string linkText = qparam.get< std::string >("linkText");
  // </%args>

#line 59 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 403 "pageelems.ecpp"

#if TNT_WATCHDOG_SILENCE
// <a href="intent://my.example.com:8080/test.mp4#Intent;scheme=http;package=org.videolan.vlc;end">OPEN IN VLC</a>

// std::string server = request.getHost();
// server = server.substr(0, server.rfind(':'));
// cToSvConcat url("intent://", server, ":", LiveSetup().GetServerPort(), "/recstream.html?recid=", recid, "#Intent;scheme=http;package=org.videolan.vlc;end");

cToSvConcat url("playlist.m3u?recid=", recid);
// orig href:  href="playlist.m3u?recid=<$ recid $>"
{

  reply.out() << _tntChunks[100]; // <a href="
#line 414 "pageelems.ecpp"
  reply.sout() << ( url );
  reply.out() << _tntChunks[101]; // " download><img src="
#line 414 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "playlist.png") );
  reply.out() << _tntChunks[102]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 414 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 414 "pageelems.ecpp"
    _tnt_cq6.add( "text", (tr("Stream this recording into media player.")));
#line 414 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << _tntChunks[103]; //  /> 
#line 414 "pageelems.ecpp"
  reply.sout() << ( linkText );
  reply.out() << _tntChunks[104]; // </a>\n
#line 415 "pageelems.ecpp"

}
#endif

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::stream_recording_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::stream_recording " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string recid = qparam.get< std::string >("recid");
std::string linkText = qparam.get< std::string >("linkText");
  // </%args>

#line 59 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 429 "pageelems.ecpp"

#if TNT_WATCHDOG_SILENCE
{
const cRecording* recording = nullptr;
if (!recid.empty()) recording = LiveRecordingsManager()->GetByMd5Hash(recid);
cToSvConcat rfid;
if (recording) {
  struct stat st;
	if (stat(recording->FileName(), &st) == 0)
		rfid.appendFormated("%lu:%llu.rec", (unsigned long) st.st_dev, (unsigned long long) st.st_ino);
}
if (!rfid.empty() ) {

  reply.out() << _tntChunks[108]; // <a href="http://localhost:
#line 441 "pageelems.ecpp"
  reply.sout() << (cToSvConcat(LiveSetup().GetStreamdevPort()));
  reply.out() << _tntChunks[109]; // /
#line 441 "pageelems.ecpp"
  reply.sout() << (rfid);
  reply.out() << _tntChunks[110]; // .ts"><img src="
#line 441 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "playlist.png") );
  reply.out() << _tntChunks[111]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 441 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 441 "pageelems.ecpp"
    _tnt_cq7.add( "text", (tr("Stream this recording.")));
#line 441 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << _tntChunks[112]; //  /> 
#line 441 "pageelems.ecpp"
  reply.sout() << ( linkText );
  reply.out() << _tntChunks[113]; // </a>\n
#line 442 "pageelems.ecpp"

}
}
#endif

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::event_timer_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::event_timer " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string epgid = qparam.get< std::string >("epgid");
  // </%args>

#line 59 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 455 "pageelems.ecpp"

	tChannelID channelid;
	tEventID eventid;
	EpgEvents::DecodeDomId(epgid, channelid, eventid);
	const cTimer* timer = LiveTimerManager().GetTimer(eventid, channelid);
	if (timer) {

  reply.out() << _tntChunks[116]; // \t\t
  // <& pageelems.edit_timer ...
  { 
#line 462 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 462 "pageelems.ecpp"
    _tnt_cq8.add( "imgName", ("record_timer.png"));
#line 462 "pageelems.ecpp"
    _tnt_cq8.add( "timerId", (LiveTimerManager().GetTimers().GetTimerId(*timer)));
#line 462 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "edit_timer"), request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << _tntChunks[117]; // \n
#line 463 "pageelems.ecpp"

	}
	else {

  reply.out() << _tntChunks[118]; // \t\t<a href="edit_timer.html\?epgid=
#line 467 "pageelems.ecpp"
  reply.sout() << ( epgid );
  reply.out() << _tntChunks[119]; // "><img src="
#line 467 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "record.png") );
  reply.out() << _tntChunks[120]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 467 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq9;
#line 467 "pageelems.ecpp"
    _tnt_cq9.add( "text", (tr("Record this")));
#line 467 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq9);
    // &>
  }
  reply.out() << _tntChunks[121]; //  /></a>\n
#line 468 "pageelems.ecpp"

	}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::edit_timer_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::edit_timer " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string timerId = qparam.get< std::string >("timerId");
std::string imgName = qparam.get< std::string >("imgName", ( "edit.png"));
  // </%args>

#line 59 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[124]; // \t<a href="edit_timer.html\?timerid=
#line 480 "pageelems.ecpp"
  reply.sout() << ( SortedTimers::EncodeDomId(timerId) );
  reply.out() << _tntChunks[125]; // "><img src="
#line 480 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", imgName) );
  reply.out() << _tntChunks[126]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 480 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq10;
#line 480 "pageelems.ecpp"
    _tnt_cq10.add( "text", (tr("Edit timer")));
#line 480 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq10);
    // &>
  }
  reply.out() << _tntChunks[127]; //  /></a>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::ajax_js_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::ajax_js " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 59 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[130]; // \t<script type="text/javascript" src="js/mootools/mootools.v1.11.js"></script>\n\t<script type="text/javascript" src="js/live/liveajax.js"></script>\n\t<script type="text/javascript" src="js/live/infowin.js"></script>\n\t<script type="text/javascript" src="js/live/hinttips.js"></script>\n\t<script type="text/javascript" src="js/live/browserwin.js"></script>\n\t<script type="text/javascript" src="js/live/pageenhance.js"></script>\n\t<script type="text/javascript"><!--\n\t\tvar liveEnhanced = new PageEnhance({\n\t\t\t\tinfoWinOptions: {\n\t\t\t\t\tbuttonimg: 'img/transparent.png',\n\t\t\t\t\tloadingMsg: '
#line 497 "pageelems.ecpp"
  reply.sout() << ( tr("loading data") );
  reply.out() << _tntChunks[131]; // ',\n\t\t\t\t\terrorMsg: '
#line 498 "pageelems.ecpp"
  reply.sout() << ( tr("an error occured!") );
  reply.out() << _tntChunks[132]; // '\n\t\t\t\t},\n\t\t\t\tnotifyStrings: {\n\t\t\t\t\tsuccessMsg: '<img src="
#line 501 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "active.png") );
  reply.out() << _tntChunks[133]; // " alt=""> 
#line 501 "pageelems.ecpp"
  reply.sout() << ( tr("Request succeeded!") );
  reply.out() << _tntChunks[134]; // ',\n\t\t\t\t\terrorMsg: '<img src="
#line 502 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "del.png") );
  reply.out() << _tntChunks[135]; // " alt=""> 
#line 502 "pageelems.ecpp"
  reply.sout() << ( tr("Request failed!") );
  reply.out() << _tntChunks[136]; // '\n\t\t\t\t}\n\t\t\t});\n\t--></script>\n
#line 506 "pageelems.ecpp"

		if (LiveSetup().GetShowInfoBox()) {

  reply.out() << _tntChunks[137]; // \t<script type="text/javascript" src="js/live/vdr_status.js"></script>\n\t<script type="text/javascript"><!--\n\t\tvar InfoBox = new LiveVdrInfo('ibox.xml', 'infobox');\n\t\twindow.addEvent('domready', function(){\n\t\t\tInfoBox.request(
#line 513 "pageelems.ecpp"
 if (update_status) { reply.sout() << "true"; } else { reply.sout() << "false"; } 
  reply.out() << _tntChunks[138]; // );\n\t\t});\n\t\twindow.addEvent('unload', function(){\n\t\t\tInfoBox.pageFinished();\n\t\t});\n\t--></script>\n
#line 519 "pageelems.ecpp"

		}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::infobox_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::infobox " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 59 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[141]; // <div id="infobox">\n\t<div class="statuscontent">\n\t\t<div class="st_header">\n\t\t\t<div id="infobox_caption" class="caption">
#line 530 "pageelems.ecpp"
  reply.sout() << ( tr("retrieving status ...") );
  reply.out() << _tntChunks[142]; // </div>\n\t\t\t<div id="infobox_timenow" class="now">--:--</div>\n\t\t</div>\n\t\t<div class="st_content">\n\t\t\t<div id="infobox_name" class="name"></div>\n\t\t\t<div id="infobox_duration" class="duration">--:--</div>\n\t\t</div>\n\t\t<div class="st_controls">\n\t\t\t<div class="st_update">\n\t\t\t\t<a href="javascript:InfoBox.toggleUpdate()" 
  // <& tooltip.hint ...
  { 
#line 539 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq11;
#line 539 "pageelems.ecpp"
    _tnt_cq11.add( "text", (tr("Toggle updates on/off.")));
#line 539 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq11);
    // &>
  }
  reply.out() << _tntChunks[143]; // ><img id="statusReloadBtn" src="
#line 539 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "stop_update.png") );
  reply.out() << _tntChunks[144]; // " alt="" /></a>\n\t\t\t</div>\n\t\t\t<div id="infobox_recording_buttons" style="display: none">\n\t\t\t\t
  // <& ajax_action_href ...
  { 
#line 542 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq12;
#line 542 "pageelems.ecpp"
    _tnt_cq12.add( "action", ("stop_recording"));
#line 542 "pageelems.ecpp"
    _tnt_cq12.add( "id", ("infobox_stop"));
#line 542 "pageelems.ecpp"
    _tnt_cq12.add( "image", ("stop.png"));
#line 542 "pageelems.ecpp"
    _tnt_cq12.add( "tip", (tr("stop playback")));
#line 542 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq12);
    // &>
  }
  reply.out() << _tntChunks[145]; // \n\t\t\t\t
  // <& ajax_action_href ...
  { 
#line 543 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq13;
#line 543 "pageelems.ecpp"
    _tnt_cq13.add( "action", ("play_recording"));
#line 543 "pageelems.ecpp"
    _tnt_cq13.add( "id", ("infobox_play"));
#line 543 "pageelems.ecpp"
    _tnt_cq13.add( "image", ("play.png"));
#line 543 "pageelems.ecpp"
    _tnt_cq13.add( "tip", (tr("resume playback")));
#line 543 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq13);
    // &>
  }
  reply.out() << _tntChunks[146]; // \n\t\t\t\t
  // <& ajax_action_href ...
  { 
#line 544 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq14;
#line 544 "pageelems.ecpp"
    _tnt_cq14.add( "action", ("pause_recording"));
#line 544 "pageelems.ecpp"
    _tnt_cq14.add( "id", ("infobox_pause"));
#line 544 "pageelems.ecpp"
    _tnt_cq14.add( "image", ("pause.png"));
#line 544 "pageelems.ecpp"
    _tnt_cq14.add( "tip", (tr("pause playback")));
#line 544 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq14);
    // &>
  }
  reply.out() << _tntChunks[147]; // \n\t\t\t\t
  // <& ajax_action_href ...
  { 
#line 545 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq15;
#line 545 "pageelems.ecpp"
    _tnt_cq15.add( "action", ("rwd_recording"));
#line 545 "pageelems.ecpp"
    _tnt_cq15.add( "id", ("infobox_rwd"));
#line 545 "pageelems.ecpp"
    _tnt_cq15.add( "image", ("rwd.png"));
#line 545 "pageelems.ecpp"
    _tnt_cq15.add( "tip", (tr("fast rewind")));
#line 545 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq15);
    // &>
  }
  reply.out() << _tntChunks[148]; // \n\t\t\t\t
  // <& ajax_action_href ...
  { 
#line 546 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq16;
#line 546 "pageelems.ecpp"
    _tnt_cq16.add( "action", ("ffw_recording"));
#line 546 "pageelems.ecpp"
    _tnt_cq16.add( "id", ("infobox_ffw"));
#line 546 "pageelems.ecpp"
    _tnt_cq16.add( "image", ("ffw.png"));
#line 546 "pageelems.ecpp"
    _tnt_cq16.add( "tip", (tr("fast forward")));
#line 546 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq16);
    // &>
  }
  reply.out() << _tntChunks[149]; // \n\t\t\t</div>\n\t\t\t<div id="infobox_channel_buttons">\n\t\t\t\t
  // <& ajax_action_href ...
  { 
#line 549 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq17;
#line 549 "pageelems.ecpp"
    _tnt_cq17.add( "action", ("switch_channel"));
#line 549 "pageelems.ecpp"
    _tnt_cq17.add( "id", ("infobox_prevchan"));
#line 549 "pageelems.ecpp"
    _tnt_cq17.add( "image", ("one_downarrow.png"));
#line 549 "pageelems.ecpp"
    _tnt_cq17.add( "tip", (tr("previous channel")));
#line 549 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq17);
    // &>
  }
  reply.out() << _tntChunks[150]; // \n\t\t\t\t
  // <& ajax_action_href ...
  { 
#line 550 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq18;
#line 550 "pageelems.ecpp"
    _tnt_cq18.add( "action", ("switch_channel"));
#line 550 "pageelems.ecpp"
    _tnt_cq18.add( "id", ("infobox_nextchan"));
#line 550 "pageelems.ecpp"
    _tnt_cq18.add( "image", ("one_uparrow.png"));
#line 550 "pageelems.ecpp"
    _tnt_cq18.add( "tip", (tr("next channel")));
#line 550 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq18);
    // &>
  }
  reply.out() << _tntChunks[151]; // \n\t\t\t</div>\n\t\t\t<div class="st_pbar">\n\t\t\t\t
  // <& progressbar ...
  { 
#line 553 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq19;
#line 553 "pageelems.ecpp"
    _tnt_cq19.add( "id", ("infobox_elapsed"));
#line 553 "pageelems.ecpp"
  main().progressbar(request, reply, _tnt_cq19);
    // &>
  }
  reply.out() << _tntChunks[152]; // \n\t\t\t</div>\n\t\t</div>\n\t</div>\n\t<div style="display: none;">\n\t\t<span id="__infobox_request_err">
#line 558 "pageelems.ecpp"
  reply.sout() << ( tr("No server response!") );
  reply.out() << _tntChunks[153]; // </span>\n\t\t<span id="__infobox_update_err">
#line 559 "pageelems.ecpp"
  reply.sout() << ( tr("Failed to update infobox!") );
  reply.out() << _tntChunks[154]; // </span>\n\t</div>\n</div>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::epg_tool_box_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::epg_tool_box " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
int detail = qparam.get< int >("detail");
std::string epgid = qparam.get< std::string >("epgid");
std::string title = qparam.get< std::string >("title");
time_t startTime = qparam.get< time_t >("startTime");
time_t endTime = qparam.get< time_t >("endTime");
int lastCurrentChanel = qparam.get< int >("lastCurrentChanel", ( int()));
std::string s_IMDB_ID = qparam.get< std::string >("s_IMDB_ID");
  // </%args>

#line 59 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 576 "pageelems.ecpp"

	int duration = EpgEvents::Duration(startTime, endTime);
	int elapsed = EpgEvents::ElapsedTime(startTime, endTime);
  tEventID eventId = tEventID();
	tChannelID channelId = tChannelID();

	EpgEvents::DecodeDomId(epgid, channelId, eventId);
	if (detail) { // output for vertical toolbox

  reply.out() << _tntChunks[157]; // \t
  // <& pageelems.event_timer ...
  { 
#line 585 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq20;
#line 585 "pageelems.ecpp"
    _tnt_cq20.add( "epgid", (epgid));
#line 585 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "event_timer"), request, reply, _tnt_cq20);
    // &>
  }
  reply.out() << _tntChunks[158]; // \n
#line 586 "pageelems.ecpp"

  if (cDevice::PrimaryDevice() && cDevice::PrimaryDevice()->HasDecoder() ) {

  reply.out() << _tntChunks[159]; // \t  
  // <& pageelems.ajax_action_href ...
  { 
#line 589 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq21;
#line 589 "pageelems.ecpp"
    _tnt_cq21.add( "action", "switch_channel");
#line 589 "pageelems.ecpp"
    _tnt_cq21.add( "alt", "");
#line 589 "pageelems.ecpp"
    _tnt_cq21.add( "image", "zap.png");
#line 589 "pageelems.ecpp"
    _tnt_cq21.add( "param", (channelId));
#line 589 "pageelems.ecpp"
    _tnt_cq21.add( "tip", (tr("Switch to this channel.")));
#line 589 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_action_href"), request, reply, _tnt_cq21);
    // &>
  }
  reply.out() << _tntChunks[160]; // \n
#line 590 "pageelems.ecpp"

	} if (LiveFeatures<features::epgsearch>().Recent() && eventId != 0) {

  reply.out() << _tntChunks[161]; // \t<a href="searchresults.html\?searchplain=
#line 593 "pageelems.ecpp"
  reply.sout() << ( StringEscapeAndBreak(title) );
  reply.out() << _tntChunks[162]; // "><img src="
#line 593 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "search.png") );
  reply.out() << _tntChunks[163]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 593 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq22;
#line 593 "pageelems.ecpp"
    _tnt_cq22.add( "text", (tr("Search for repeats.")));
#line 593 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq22);
    // &>
  }
  reply.out() << _tntChunks[164]; //  /></a>\n
#line 594 "pageelems.ecpp"

		}
		if ((duration == 0) || (elapsed >= 0)) {

  reply.out() << _tntChunks[165]; // \t
  // <& pageelems.hls_channel ...
  { 
#line 598 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq23;
#line 598 "pageelems.ecpp"
    _tnt_cq23.add( "channelId", (channelId));
#line 598 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "hls_channel"), request, reply, _tnt_cq23);
    // &>
  }
  reply.out() << _tntChunks[166]; // \n\t
  // <& pageelems.m3u_playlist_channel ...
  { 
#line 599 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq24;
#line 599 "pageelems.ecpp"
    _tnt_cq24.add( "channelId", (channelId));
#line 599 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "m3u_playlist_channel"), request, reply, _tnt_cq24);
    // &>
  }
  reply.out() << _tntChunks[167]; // \n
#line 600 "pageelems.ecpp"

		}
	if (eventId != 0) {
    /* Need to lock here channels also, because CreateEpgInfo will lock
     * it also and this will result in a wrong lock order */
    LOCK_CHANNELS_READ;
    LOCK_SCHEDULES_READ;
    EpgInfoPtr epgEvent = EpgEvents::CreateEpgInfo(epgid, Schedules);
    const cEvent* event = epgEvent->Event();
    const cChannel* channel = event?Channels->GetByChannelID(event->ChannelID()):nullptr;
    cGetScraperVideo getScraperVideo(event, NULL);
    bool scraperDataAvailable = getScraperVideo.call(LiveSetup().GetPluginScraper());
    if (scraperDataAvailable) {
      int video_SD_HD = getScraperVideo.m_scraperVideo->getHD();
      const char *sdhd = video_SD_HD == 0 ? "sd": video_SD_HD == 1 ? "hd": video_SD_HD == 2 ? "ud" : 0;


  reply.out() << _tntChunks[168]; // \t\t
  // <& pageelems.imdb_info_href ...
  { 
#line 617 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq25;
#line 617 "pageelems.ecpp"
    _tnt_cq25.add( "s_IMDB_ID", (s_IMDB_ID));
#line 617 "pageelems.ecpp"
    _tnt_cq25.add( "title", (title));
#line 617 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq25);
    // &>
  }
  reply.out() << _tntChunks[169]; // \n
#line 618 "pageelems.ecpp"
 if (detail > 1) {

  reply.out() << _tntChunks[170]; // <img data-src="img/transparent.png" height="10px" />\n<span id="icons-
#line 620 "pageelems.ecpp"
  reply.sout() << (epgid);
  reply.out() << _tntChunks[171]; // "></span>\n
#line 621 "pageelems.ecpp"
 if (sdhd) { 
  reply.out() << _tntChunks[172]; // \t\t\t\t\t<script class="injectIcons">\n\t\t\t\t\tinjectHdSdIcon("icons-
#line 623 "pageelems.ecpp"
  reply.sout() << (epgid);
  reply.out() << _tntChunks[173]; // ", "
#line 623 "pageelems.ecpp"
  reply.sout() << (sdhd);
  reply.out() << _tntChunks[174]; // ", "
#line 623 "pageelems.ecpp"
  reply.sout() << ((channel&&channel->Name())?channel->Name():"");
  reply.out() << _tntChunks[175]; // ", "")\n\t\t\t\t\t</script>\n
#line 625 "pageelems.ecpp"

				}
		  }
		}
		}
	}
	else { // table output

  reply.out() << _tntChunks[176]; // \t\t<td class="action leftcol 
#line 633 "pageelems.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[177]; // ">
  // <& pageelems.event_timer ...
  { 
#line 633 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq26;
#line 633 "pageelems.ecpp"
    _tnt_cq26.add( "epgid", (epgid));
#line 633 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "event_timer"), request, reply, _tnt_cq26);
    // &>
  }
  reply.out() << _tntChunks[178]; // </td>\n
#line 634 "pageelems.ecpp"

    if (cDevice::PrimaryDevice() && cDevice::PrimaryDevice()->HasDecoder() ) {

  reply.out() << _tntChunks[179]; // \t\t<td class="action 
#line 637 "pageelems.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[180]; // ">
  // <& pageelems.ajax_action_href ...
  { 
#line 637 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq27;
#line 637 "pageelems.ecpp"
    _tnt_cq27.add( "action", "switch_channel");
#line 637 "pageelems.ecpp"
    _tnt_cq27.add( "alt", "");
#line 637 "pageelems.ecpp"
    _tnt_cq27.add( "image", "zap.png");
#line 637 "pageelems.ecpp"
    _tnt_cq27.add( "param", (channelId));
#line 637 "pageelems.ecpp"
    _tnt_cq27.add( "tip", (tr("Switch to this channel.")));
#line 637 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_action_href"), request, reply, _tnt_cq27);
    // &>
  }
  reply.out() << _tntChunks[181]; // </td>\n\t\t
#line 638 "pageelems.ecpp"
 } if (LiveFeatures<features::epgsearch>().Recent()) { 
  reply.out() << _tntChunks[182]; // \t\t<td class="action 
#line 639 "pageelems.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[183]; // ">\n\t\t\t
#line 640 "pageelems.ecpp"
 if (eventId) { 
  reply.out() << _tntChunks[184]; // \t\t\t<a href="searchresults.html\?searchplain=
#line 641 "pageelems.ecpp"
  reply.sout() << ( StringUrlEncode(title) );
  reply.out() << _tntChunks[185]; // "><img src="
#line 641 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "search.png") );
  reply.out() << _tntChunks[186]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 641 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq28;
#line 641 "pageelems.ecpp"
    _tnt_cq28.add( "text", (tr("Search for repeats.")));
#line 641 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq28);
    // &>
  }
  reply.out() << _tntChunks[187]; //  /></a></td>\n\t\t
#line 642 "pageelems.ecpp"
 } } 
  reply.out() << _tntChunks[188]; // \t\t<td class="action 
#line 643 "pageelems.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[189]; // ">
#line 643 "pageelems.ecpp"
if ((duration == 0) || (elapsed > 0)) { 
  // <& pageelems.hls_channel ...
  { 
#line 643 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq29;
#line 643 "pageelems.ecpp"
    _tnt_cq29.add( "channelId", (channelId));
#line 643 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "hls_channel"), request, reply, _tnt_cq29);
    // &>
  }
#line 643 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[190]; // </td>\n\t\t
#line 644 "pageelems.ecpp"
 if (LiveSetup().GetShowPlayMediaplayer() ) { 
  reply.out() << _tntChunks[191]; // \t\t<td class="action 
#line 645 "pageelems.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[192]; // ">
#line 645 "pageelems.ecpp"
if ((duration == 0) || (elapsed > 0)) { 
  // <& pageelems.m3u_playlist_channel ...
  { 
#line 645 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq30;
#line 645 "pageelems.ecpp"
    _tnt_cq30.add( "channelId", (channelId));
#line 645 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "m3u_playlist_channel"), request, reply, _tnt_cq30);
    // &>
  }
#line 645 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[193]; // </td>\n\t\t
#line 646 "pageelems.ecpp"
 } if (LiveSetup().GetShowIMDb() ) { 
  reply.out() << _tntChunks[194]; // \t\t<td class="action 
#line 647 "pageelems.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[195]; // ">\n
#line 648 "pageelems.ecpp"

			if (eventId != 0) {

  reply.out() << _tntChunks[196]; // \t\t\t
  // <& pageelems.imdb_info_href ...
  { 
#line 651 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq31;
#line 651 "pageelems.ecpp"
    _tnt_cq31.add( "s_IMDB_ID", (s_IMDB_ID));
#line 651 "pageelems.ecpp"
    _tnt_cq31.add( "title", (title));
#line 651 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq31);
    // &>
  }
  reply.out() << _tntChunks[197]; // \n
#line 652 "pageelems.ecpp"

			}

  reply.out() << _tntChunks[198]; // \t\t</td>\n
#line 656 "pageelems.ecpp"

	} }

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::epg_tt_box_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::epg_tt_box " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string boxId = qparam.get< std::string >("boxId");
std::string caption = qparam.get< std::string >("caption");
std::string tools_comp = qparam.get< std::string >("tools_comp");
std::string time = qparam.get< std::string >("time");
std::string channel = qparam.get< std::string >("channel");
std::string title = qparam.get< std::string >("title");
std::string short_descr = qparam.get< std::string >("short_descr");
std::string long_descr = qparam.get< std::string >("long_descr");
std::string filename = qparam.get< std::string >("filename");
std::string archived = qparam.get< std::string >("archived");
std::string epgImage = qparam.get< std::string >("epgImage");
uintptr_t ievent = qparam.get< uintptr_t >("ievent");
uintptr_t irecording = qparam.get< uintptr_t >("irecording");
uintptr_t iepgEvent = qparam.get< uintptr_t >("iepgEvent");
int elapsed = qparam.get< int >("elapsed", ( -1));
std::string sort = qparam.get< std::string >("sort");
std::string filter = qparam.get< std::string >("filter");
std::string flat = qparam.get< std::string >("flat");
int history_num_back = qparam.get< int >("history_num_back", ( 0));
  // </%args>

#line 59 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[201]; // \t<div class="epg_description" id="
#line 685 "pageelems.ecpp"
  reply.sout() << ( (boxId) );
  reply.out() << _tntChunks[202]; // ">\n\t\t<div class="station">\n\t\t\t<div class="boxheader">\n\n<div>\n
#line 690 "pageelems.ecpp"

struct sEpisode2 {
    int number;
    int season;
    int absoluteNumber;
    std::string name;
    std::string firstAired;
    int runtime;
    std::string overview;
    float vote_average;
    int vote_count;
    cTvMedia episodeImage;
    std::string IMDB_ID;
};
struct sScraperMovieOrTv {
    bool found;
    bool movie;
    std::string title;
    std::string originalTitle;
    std::string tagline;
    std::string overview;
    std::vector<std::string> genres;
    std::string homepage;
    std::string releaseDate;  // for TV shows: firstAired
    bool adult;
    int runtime;
    float popularity;
    float voteAverage;
    int voteCount;
    std::vector<std::string> productionCountries;
    std::string IMDB_ID;
    std::vector<cTvMedia> posters;
    std::vector<cTvMedia> banners;
    std::vector<cTvMedia> fanarts;
// only for movies
    int budget;
    int revenue;
    int collectionId;
    std::string collectionName;
// only for TV Shows
    std::string status;
    std::vector<std::string> networks;
    int lastSeason;
// episode related
    bool episodeFound;
    cTvMedia seasonPoster;
    sEpisode2 episode;
};

EpgInfoPtr epgEvent;
if (iepgEvent) epgEvent = *static_cast<EpgInfoPtr*>((void *)iepgEvent);


sScraperMovieOrTv scraperMovieOrTv;
cGetScraperVideo getScraperVideo(static_cast<cEvent *>((void *)ievent), static_cast<cRecording *>((void *)irecording));
scraperMovieOrTv.found = getScraperVideo.call(LiveSetup().GetPluginScraper());
if (scraperMovieOrTv.found) {
  tvType type = getScraperVideo.m_scraperVideo->getVideoType();
//  esyslog("live: type = %i", (int)type);
  if (type == tMovie) scraperMovieOrTv.movie = true;
  else {
    if (type == tSeries) scraperMovieOrTv.movie = false;
    else scraperMovieOrTv.found = false;
  }
}
if (scraperMovieOrTv.found) {
  scraperMovieOrTv.found = getScraperVideo.m_scraperVideo->getMovieOrTv(&scraperMovieOrTv.title, &scraperMovieOrTv.originalTitle, &scraperMovieOrTv.tagline, &scraperMovieOrTv.overview, &scraperMovieOrTv.genres, &scraperMovieOrTv.homepage, &scraperMovieOrTv.releaseDate, &scraperMovieOrTv.adult, &scraperMovieOrTv.runtime, &scraperMovieOrTv.popularity, &scraperMovieOrTv.voteAverage, &scraperMovieOrTv.voteCount, &scraperMovieOrTv.productionCountries, &scraperMovieOrTv.IMDB_ID, &scraperMovieOrTv.budget, &scraperMovieOrTv.revenue, &scraperMovieOrTv.collectionId, &scraperMovieOrTv.collectionName, &scraperMovieOrTv.status, &scraperMovieOrTv.networks, &scraperMovieOrTv.lastSeason);
}
std::vector<std::unique_ptr<cCharacter>> scraperCharacters;
if (scraperMovieOrTv.found) {
  scraperCharacters = getScraperVideo.m_scraperVideo->getCharacters(false);
  scraperMovieOrTv.posters = getScraperVideo.m_scraperVideo->getImages(eOrientation::portrait, 3, false);
  scraperMovieOrTv.banners = getScraperVideo.m_scraperVideo->getImages(eOrientation::banner, 3, false);
  scraperMovieOrTv.fanarts = getScraperVideo.m_scraperVideo->getImages(eOrientation::landscape, 3, false);
  scraperMovieOrTv.episodeFound = getScraperVideo.m_scraperVideo->getEpisode(&scraperMovieOrTv.episode.name, &scraperMovieOrTv.episode.overview, &scraperMovieOrTv.episode.absoluteNumber, &scraperMovieOrTv.episode.firstAired, &scraperMovieOrTv.episode.runtime, &scraperMovieOrTv.episode.vote_average, &scraperMovieOrTv.episode.vote_count, &scraperMovieOrTv.episode.IMDB_ID);
  if (scraperMovieOrTv.episodeFound) {
    scraperMovieOrTv.episode.number = getScraperVideo.m_scraperVideo->getEpisodeNumber();
    scraperMovieOrTv.episode.season = getScraperVideo.m_scraperVideo->getSeasonNumber();
    scraperMovieOrTv.episode.episodeImage = getScraperVideo.m_scraperVideo->getImage(cImageLevels(eImageLevel::episodeMovie), cOrientations(eOrientation::landscape), false);
    scraperMovieOrTv.seasonPoster = getScraperVideo.m_scraperVideo->getImage(cImageLevels(eImageLevel::seasonMovie), cOrientations(eOrientation::portrait), false);
  }
}

const bool episodeFound = scraperMovieOrTv.found && (!scraperMovieOrTv.movie) && scraperMovieOrTv.episodeFound;
if (scraperMovieOrTv.found) {
//  esyslog("live: create caption menu");

  reply.out() << _tntChunks[203]; // <div class = "caption">\n  <a id="
#line 778 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[204]; // _epg_m"     class = "active"   onclick="displayEPG('
#line 778 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[205]; // ')" >
#line 778 "pageelems.ecpp"
  reply.sout() << ( trVDR("EPG") );
  reply.out() << _tntChunks[206]; // </a>\n| <a id="
#line 779 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[207]; // _scraper_m" class = "inactive" onclick="displayScraper('
#line 779 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[208]; // ')">
#line 779 "pageelems.ecpp"
  reply.sout() << ( tr("Scraper") );
  reply.out() << _tntChunks[209]; // </a>\n| <a id="
#line 780 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[210]; // _actors_m"  class = "inactive" onclick="displayActors('
#line 780 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[211]; // ')" >
#line 780 "pageelems.ecpp"
  reply.sout() << ( tr("Actors") );
  reply.out() << _tntChunks[212]; // </a>\n| <a id="
#line 781 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[213]; // _artwork_m" class = "inactive" onclick="displayArtwork('
#line 781 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[214]; // ')" >
#line 781 "pageelems.ecpp"
  reply.sout() << ( tr("Artwork") );
  reply.out() << _tntChunks[215]; // </a>\n</div>\n
#line 783 "pageelems.ecpp"

} else {

  reply.out() << _tntChunks[216]; // <div class="caption">
#line 786 "pageelems.ecpp"
  reply.sout() << ( (caption) );
  reply.out() << _tntChunks[217]; // </div>\n
#line 787 "pageelems.ecpp"

}

  reply.out() << _tntChunks[218]; // </div>\n                        </div>\n\t\t</div>\n\t\t<div class="epg_content">\n\t\t\t<div class="epg_tools">\n\t\t\t\t
  // <& (tools_comp) ...
  { 
#line 795 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq32;
#line 795 "pageelems.ecpp"
    _tnt_cq32.add( "archived", (archived));
#line 795 "pageelems.ecpp"
    _tnt_cq32.add( "detail", (2));
#line 795 "pageelems.ecpp"
    _tnt_cq32.add( "filter", (filter));
#line 795 "pageelems.ecpp"
    _tnt_cq32.add( "flat", (flat));
#line 795 "pageelems.ecpp"
    _tnt_cq32.add( "history_num_back", (history_num_back));
#line 795 "pageelems.ecpp"
    _tnt_cq32.add( "id", (boxId));
#line 795 "pageelems.ecpp"
    _tnt_cq32.add( "s_IMDB_ID", (scraperMovieOrTv.IMDB_ID));
#line 795 "pageelems.ecpp"
    _tnt_cq32.add( "sort", (sort));
#line 795 "pageelems.ecpp"
    _tnt_cq32.add( "title", (title));
#line 795 "pageelems.ecpp"
    callComp((tools_comp), request, reply, _tnt_cq32);
    // &>
  }
  reply.out() << _tntChunks[219]; // \n\t\t\t</div>\n\t\t\t<div class="epg_info">\n\t\t\t\t<div class="info">\n\t\t\t\t\t<div class="duration">\n
#line 800 "pageelems.ecpp"

if (epgEvent && epgEvent->EventDuration() >= 0) {  // recording

  reply.out() << _tntChunks[220]; // \t\t\t\t\t\t<span title="
#line 803 "pageelems.ecpp"
  reply.sout() << (tr("Recording length"));
  reply.out() << _tntChunks[221]; // ">
#line 803 "pageelems.ecpp"
  reply.sout() << ( FormatDuration(tr("%d:%02d"), epgEvent->Duration()));
  reply.out() << _tntChunks[222]; // </span> / <span title="
#line 803 "pageelems.ecpp"
  reply.sout() << (tr("Event duration"));
  reply.out() << _tntChunks[223]; // ">
#line 803 "pageelems.ecpp"
  reply.sout() << (FormatDuration(tr("%d:%02d"), epgEvent->EventDuration()));
  reply.out() << _tntChunks[224]; // </span>\n
#line 804 "pageelems.ecpp"

}
if (elapsed >= 0) {

  reply.out() << _tntChunks[225]; // \t\t\t\t\t\t<div class="progress"><div>
  // <& pageelems.progressbar ...
  { 
#line 808 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq33;
#line 808 "pageelems.ecpp"
    _tnt_cq33.add( "progress", (elapsed));
#line 808 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "progressbar"), request, reply, _tnt_cq33);
    // &>
  }
  reply.out() << _tntChunks[226]; // </div></div>\n
#line 809 "pageelems.ecpp"

}

  reply.out() << _tntChunks[227]; // \t\t\t\t\t</div>\n\t\t\t\t\t<div class="time">\n
#line 814 "pageelems.ecpp"
           if (!archived.empty()) {

  reply.out() << _tntChunks[228]; //               <span class="bold">
#line 815 "pageelems.ecpp"
  reply.sout() << ( (archived + " ") );
  reply.out() << _tntChunks[229]; // </span>\n
#line 816 "pageelems.ecpp"
           }

  reply.out() << _tntChunks[230]; //             
#line 817 "pageelems.ecpp"
  reply.sout() << ( (time) );
  reply.out() << _tntChunks[231]; // \n
#line 818 "pageelems.ecpp"
           if (!filename.empty() && !channel.empty()) {

  reply.out() << _tntChunks[232]; //               <div class="channel">
#line 819 "pageelems.ecpp"
  reply.sout() << ( (channel) );
  reply.out() << _tntChunks[233]; // </div>\n
#line 820 "pageelems.ecpp"
           }

  reply.out() << _tntChunks[234]; // \t\t\t\t\t</div>\n\t\t\t\t\t<div class="title">
#line 822 "pageelems.ecpp"
  reply.sout() << ( (title) );
  reply.out() << _tntChunks[235]; // </div>\n\t\t\t\t\t<div class="short">
#line 823 "pageelems.ecpp"
  reply.sout() << ( (short_descr) );
  reply.out() << _tntChunks[236]; // </div>\n\t\t\t\t\t<div class="description" id=
#line 824 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[237]; // _description>\n\t\t\t\t\t<span id = "
#line 825 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[238]; // _epg_image" class="epg_images">\n
#line 826 "pageelems.ecpp"

	std::list<std::string> images = EpgEvents::EpgImages(boxId);
	for(std::list<std::string>::iterator it = images.begin(); it != images.end(); ++it ) {

  reply.out() << _tntChunks[239]; //          <a href="/epgimages/
#line 830 "pageelems.ecpp"
  reply.sout() << ( *it );
  reply.out() << _tntChunks[240]; // " target="_blank">\n\t\t\t\t\t\t<img src="/epgimages/
#line 831 "pageelems.ecpp"
  reply.sout() << ( *it );
  reply.out() << _tntChunks[241]; // " class="epg_image"/>\n         </a>\n
#line 833 "pageelems.ecpp"
 } bool scraperImage = false;

#line 834 "pageelems.ecpp"
 if(!epgImage.empty() ) { scraperImage = true;

  reply.out() << _tntChunks[242]; //     <a href="/tvscraper/
#line 835 "pageelems.ecpp"
  reply.sout() << ( epgImage );
  reply.out() << _tntChunks[243]; // " target="_blank">\n\t    <img src="/tvscraper/
#line 836 "pageelems.ecpp"
  reply.sout() << ( epgImage );
  reply.out() << _tntChunks[244]; // " class="epg_image"/>\n    </a>\n
#line 838 "pageelems.ecpp"
 } if (episodeFound && !scraperMovieOrTv.episode.episodeImage.path.empty() ) { scraperImage = true;

  reply.out() << _tntChunks[245]; //     <a href="/tvscraper/
#line 839 "pageelems.ecpp"
  reply.sout() << ( scraperMovieOrTv.episode.episodeImage.path );
  reply.out() << _tntChunks[246]; // " target="_blank">\n      <img src="/tvscraper/
#line 840 "pageelems.ecpp"
  reply.sout() << ( scraperMovieOrTv.episode.episodeImage.path );
  reply.out() << _tntChunks[247]; // " class="epg_image"/>\n    </a>\n
#line 842 "pageelems.ecpp"

  }  // episodeFound && !scraperMovieOrTv.episode.episodeImage.path.empty()
	if (!scraperImage) {
    std::list<std::string> images1 = EpgEvents::RecImages(boxId, filename);
    size_t delimPos = boxId.find_last_of('_');
    std::string recId = (delimPos)?boxId.substr(delimPos+1):boxId;

    for(std::list<std::string>::iterator it = images1.begin(); it != images1.end(); ++it ) {

  reply.out() << _tntChunks[248]; //       <a href="/recimages/
#line 851 "pageelems.ecpp"
  reply.sout() << ( recId );
  reply.out() << _tntChunks[249]; // /
#line 851 "pageelems.ecpp"
  reply.sout() << ( *it );
  reply.out() << _tntChunks[250]; // " target="_blank">\n\t\t\t\t<img src="/recimages/
#line 852 "pageelems.ecpp"
  reply.sout() << ( recId );
  reply.out() << _tntChunks[251]; // /
#line 852 "pageelems.ecpp"
  reply.sout() << ( *it );
  reply.out() << _tntChunks[252]; // " class="epg_image"/>\n      </a>\n
#line 854 "pageelems.ecpp"

    }
  }

  reply.out() << _tntChunks[253]; // \t\t\t\t\t</span> 
  reply.out() << _tntChunks[254]; // \n\n
  reply.out() << _tntChunks[255]; // \n<div id = '
#line 861 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[256]; // _scraper' hidden>\n
#line 862 "pageelems.ecpp"

if (scraperMovieOrTv.found) {

  reply.out() << _tntChunks[257]; //   <div class="scraper_list">
#line 865 "pageelems.ecpp"
  reply.sout() << ( tr("Title:") );
  reply.out() << _tntChunks[258]; //          
#line 865 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.title ) );
  reply.out() << _tntChunks[259]; // </div>\n
#line 866 "pageelems.ecpp"

  if (!scraperMovieOrTv.originalTitle.empty() ) {

  reply.out() << _tntChunks[260]; //   <div class="scraper_list">
#line 869 "pageelems.ecpp"
  reply.sout() << ( tr("Original title:") );
  reply.out() << _tntChunks[261]; //  
#line 869 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.originalTitle ) );
  reply.out() << _tntChunks[262]; // </div>\n
#line 870 "pageelems.ecpp"

  }
  if (episodeFound) {

  reply.out() << _tntChunks[263]; //     <div class="scraper_list">
#line 874 "pageelems.ecpp"
  reply.sout() << ( tr("Episode:") );
  reply.out() << _tntChunks[264]; //  S
#line 874 "pageelems.ecpp"
  reply.sout() << ( cSv(cToSvInt(scraperMovieOrTv.episode.season )) );
  reply.out() << _tntChunks[265]; // E
#line 874 "pageelems.ecpp"
  reply.sout() << ( cSv(cToSvInt(scraperMovieOrTv.episode.number)) );
#line 874 "pageelems.ecpp"
  reply.sout() << (scraperMovieOrTv.episode.absoluteNumber?concat("A", cToSvInt(scraperMovieOrTv.episode.absoluteNumber)):"");
  reply.out() << _tntChunks[266]; //  
#line 874 "pageelems.ecpp"
  reply.sout() << ( scraperMovieOrTv.episode.name );
  reply.out() << _tntChunks[267]; // </div>\n    <div class="scraper_list">
#line 875 "pageelems.ecpp"
  reply.sout() << ( tr("Episode overview:") );
  reply.out() << _tntChunks[268]; //    
#line 875 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.overview ) );
  reply.out() << _tntChunks[269]; // </div>\n
#line 876 "pageelems.ecpp"

    if (scraperMovieOrTv.episode.vote_average != 0 ) {

  reply.out() << _tntChunks[270]; //       <div class="scraper_list">
#line 879 "pageelems.ecpp"
  reply.sout() << ( tr("Episode vote average/count:") );
  reply.out() << _tntChunks[271]; //  
#line 879 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.vote_average) );
  reply.out() << _tntChunks[272]; //  / 
#line 879 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.vote_count ) );
  reply.out() << _tntChunks[273]; // </div>\n
#line 880 "pageelems.ecpp"

    }

  reply.out() << _tntChunks[274]; //     <div class="scraper_list">
#line 883 "pageelems.ecpp"
  reply.sout() << ( tr("Episode first aired:") );
  reply.out() << _tntChunks[275]; //  
#line 883 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.firstAired ) );
  reply.out() << _tntChunks[276]; // </div>\n
#line 884 "pageelems.ecpp"
   if (scraperMovieOrTv.episode.runtime > 0) {

  reply.out() << _tntChunks[277]; //       <div class="scraper_list">
#line 885 "pageelems.ecpp"
  reply.sout() << ( tr("Episode runtime:") );
  reply.out() << _tntChunks[278]; //  
#line 885 "pageelems.ecpp"
  reply.sout() << ( FormatDuration(tr("%d:%02d"), scraperMovieOrTv.episode.runtime*60) );
  reply.out() << _tntChunks[279]; // </div>\n
#line 886 "pageelems.ecpp"
   }

#line 887 "pageelems.ecpp"
   if (!scraperMovieOrTv.episode.IMDB_ID.empty() ) {

  reply.out() << _tntChunks[280]; //       <a href="https://www.imdb.com/title/
#line 888 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.IMDB_ID ) );
  reply.out() << _tntChunks[281]; // " target="_blank"> 
#line 888 "pageelems.ecpp"
  reply.sout() << ( tr("IMDB episode") );
  reply.out() << _tntChunks[282]; //  </a>\n
#line 889 "pageelems.ecpp"

    }
    bool charFound = false;
    for (const auto &character:scraperCharacters)
      if (character->getType() == eCharacterType::guestStar ||
          character->getType() == eCharacterType::writer ||
          character->getType() == eCharacterType::director) { charFound = true; break; }
    if (charFound) {

  reply.out() << _tntChunks[283]; //       <div class="scraper_list">
#line 898 "pageelems.ecpp"
  reply.sout() << ( tr("Guest stars and crew") );
  reply.out() << _tntChunks[284]; // </div>\n      <table>\n
#line 900 "pageelems.ecpp"
   for (const auto &character:scraperCharacters) {

#line 901 "pageelems.ecpp"
     if (character->getType() != eCharacterType::guestStar) continue;

  reply.out() << _tntChunks[285]; //       <tr>\n        <td class="cast_role"> 
#line 903 "pageelems.ecpp"
  reply.sout() << ( character->getCharacterName() );
  reply.out() << _tntChunks[286]; //  </td>\n        <td> 
#line 904 "pageelems.ecpp"
  reply.sout() << ( character->getPersonName() );
  reply.out() << _tntChunks[287]; //  </td>\n      </tr>\n
#line 906 "pageelems.ecpp"
   }

#line 907 "pageelems.ecpp"
   for (const auto &character:scraperCharacters) {

#line 908 "pageelems.ecpp"
     if (character->getType() != eCharacterType::writer) continue;

  reply.out() << _tntChunks[288]; //       <tr>\n        <td class="cast_role"> 
#line 910 "pageelems.ecpp"
  reply.sout() << ( tr("Writer") );
  reply.out() << _tntChunks[289]; //  </td>\n        <td> 
#line 911 "pageelems.ecpp"
  reply.sout() << ( character->getPersonName() );
  reply.out() << _tntChunks[290]; //  </td>\n      </tr>\n
#line 913 "pageelems.ecpp"
   }

#line 914 "pageelems.ecpp"
   for (const auto &character:scraperCharacters) {

#line 915 "pageelems.ecpp"
     if (character->getType() != eCharacterType::director) continue;

  reply.out() << _tntChunks[291]; //       <tr>\n        <td class="cast_role"> 
#line 917 "pageelems.ecpp"
  reply.sout() << ( tr("Director") );
  reply.out() << _tntChunks[292]; //  </td>\n        <td> 
#line 918 "pageelems.ecpp"
  reply.sout() << ( character->getPersonName() );
  reply.out() << _tntChunks[293]; //  </td>\n      </tr>\n
#line 920 "pageelems.ecpp"
   }

  reply.out() << _tntChunks[294]; //       </table>\n
#line 922 "pageelems.ecpp"

    }  // end if !episode.<Guest stars and crew>.empty()
  }  // end if episode found
  if (!scraperMovieOrTv.tagline.empty() ) {

  reply.out() << _tntChunks[295]; //   <div class="scraper_list">
#line 927 "pageelems.ecpp"
  reply.sout() << ( tr("Tagline:") );
  reply.out() << _tntChunks[296]; //         
#line 927 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.tagline ) );
  reply.out() << _tntChunks[297]; // </div>\n
#line 928 "pageelems.ecpp"
 }

  reply.out() << _tntChunks[298]; //   <div class="scraper_list">
#line 929 "pageelems.ecpp"
  reply.sout() << ( tr("Overview:") );
  reply.out() << _tntChunks[299]; //        
#line 929 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.overview ) );
  reply.out() << _tntChunks[300]; // </div>\n  <div class="scraper_list">
#line 930 "pageelems.ecpp"
  reply.sout() << ( tr("Genres:") );
  reply.out() << _tntChunks[301]; //          
#line 930 "pageelems.ecpp"
  reply.sout() << ( toString(scraperMovieOrTv.genres ) );
  reply.out() << _tntChunks[302]; // </div>\n
#line 931 "pageelems.ecpp"
 if (!scraperMovieOrTv.homepage.empty() ) {

  reply.out() << _tntChunks[303]; //   <div class="scraper_list"><a href ="
#line 932 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.homepage) );
  reply.out() << _tntChunks[304]; // " target="_blank">
#line 932 "pageelems.ecpp"
  reply.sout() << ( tr("Homepage") );
  reply.out() << _tntChunks[305]; // </a></div>\n
#line 933 "pageelems.ecpp"
 }

  reply.out() << _tntChunks[306]; //   <div class="scraper_list">
#line 934 "pageelems.ecpp"
  reply.sout() << ( tr("Release date:") );
  reply.out() << _tntChunks[307]; //    
#line 934 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.releaseDate ) );
  reply.out() << _tntChunks[308]; // </div>\n
#line 935 "pageelems.ecpp"
 if (scraperMovieOrTv.runtime > 0) {

  reply.out() << _tntChunks[309]; //   <div class="scraper_list">
#line 936 "pageelems.ecpp"
  reply.sout() << ( tr("Runtime:") );
  reply.out() << _tntChunks[310]; //         
#line 936 "pageelems.ecpp"
  reply.sout() << ( FormatDuration(tr("%d:%02d"), scraperMovieOrTv.runtime*60) );
  reply.out() << _tntChunks[311]; // </div>\n
#line 937 "pageelems.ecpp"
 }

#line 938 "pageelems.ecpp"

  if (scraperMovieOrTv.popularity != 0) {

  reply.out() << _tntChunks[312]; //   <div class="scraper_list">
#line 941 "pageelems.ecpp"
  reply.sout() << ( tr("Popularity:") );
  reply.out() << _tntChunks[313]; //      
#line 941 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.popularity ) );
  reply.out() << _tntChunks[314]; // </div>\n
#line 942 "pageelems.ecpp"

  }
  if (scraperMovieOrTv.voteAverage  != 0) {

  reply.out() << _tntChunks[315]; //   <div class="scraper_list">
#line 946 "pageelems.ecpp"
  reply.sout() << ( tr("Vote average/count:") );
  reply.out() << _tntChunks[316]; //  
#line 946 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.voteAverage ) );
  reply.out() << _tntChunks[317]; //  / 
#line 946 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.voteCount) );
  reply.out() << _tntChunks[318]; // </div>\n
#line 947 "pageelems.ecpp"

  }

  reply.out() << _tntChunks[319]; // \n
#line 953 "pageelems.ecpp"
 if (!scraperMovieOrTv.IMDB_ID.empty() ) {

  reply.out() << _tntChunks[320]; //     <div class="scraper_list">\n      <a href="https://www.imdb.com/title/
#line 955 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.IMDB_ID ) );
  reply.out() << _tntChunks[321]; // " target="_blank"> 
#line 955 "pageelems.ecpp"
  reply.sout() << ( tr("IMDB") );
  reply.out() << _tntChunks[322]; //  </a>\n    </div>\n
#line 957 "pageelems.ecpp"
 }

  reply.out() << _tntChunks[323]; // \n
#line 962 "pageelems.ecpp"

  if (scraperMovieOrTv.movie) {
    if (scraperMovieOrTv.budget) {

  reply.out() << _tntChunks[324]; //     <div class="scraper_list">
#line 966 "pageelems.ecpp"
  reply.sout() << ( tr("Budget:") );
  reply.out() << _tntChunks[325]; //          
#line 966 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.budget ) );
  reply.out() << _tntChunks[326]; // </div>\n
#line 967 "pageelems.ecpp"

    }
    if (scraperMovieOrTv.revenue) {

  reply.out() << _tntChunks[327]; //     <div class="scraper_list">
#line 971 "pageelems.ecpp"
  reply.sout() << ( tr("Revenue:") );
  reply.out() << _tntChunks[328]; //         
#line 971 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.revenue) );
  reply.out() << _tntChunks[329]; // </div>\n
#line 972 "pageelems.ecpp"

    }

  reply.out() << _tntChunks[330]; // \n
#line 978 "pageelems.ecpp"

    if (!scraperMovieOrTv.collectionName.empty() ) {

  reply.out() << _tntChunks[331]; //     <div class="scraper_list">
#line 981 "pageelems.ecpp"
  reply.sout() << ( tr("Collection name:") );
  reply.out() << _tntChunks[332]; //  
#line 981 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.collectionName) );
  reply.out() << _tntChunks[333]; // </div>\n
#line 982 "pageelems.ecpp"

    }
  } else {  // TV show

  reply.out() << _tntChunks[334]; //     <div class="scraper_list">
#line 986 "pageelems.ecpp"
  reply.sout() << ( tr("Status:") );
  reply.out() << _tntChunks[335]; //          
#line 986 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.status    ) );
  reply.out() << _tntChunks[336]; // </div>\n
  reply.out() << _tntChunks[337]; // \n
#line 990 "pageelems.ecpp"

  }
  bool charFound = false;
  for (const auto &character:scraperCharacters)
    if (character->getType() == eCharacterType::actor) { charFound = true; break; }
  if (!charFound && scraperMovieOrTv.movie) {
    for (const auto &character:scraperCharacters)
      if (character->getType() == eCharacterType::writer ||
          character->getType() == eCharacterType::director) { charFound = true; break; }
  }
  if (charFound) {

  reply.out() << _tntChunks[338]; //     <div class="scraper_list">
#line 1002 "pageelems.ecpp"
  reply.sout() << ( tr("Cast and crew") );
  reply.out() << _tntChunks[339]; // </div>\n    <table>\n
#line 1004 "pageelems.ecpp"
   for (const auto &character:scraperCharacters) {

#line 1005 "pageelems.ecpp"
     if (character->getType() != eCharacterType::actor) continue;

  reply.out() << _tntChunks[340]; //       <tr>\n        <td class="cast_role"> 
#line 1007 "pageelems.ecpp"
  reply.sout() << ( character->getCharacterName() );
  reply.out() << _tntChunks[341]; //  </td>\n        <td> 
#line 1008 "pageelems.ecpp"
  reply.sout() << ( character->getPersonName() );
  reply.out() << _tntChunks[342]; //  </td>\n      </tr>\n
#line 1010 "pageelems.ecpp"
   }

#line 1011 "pageelems.ecpp"
   if (scraperMovieOrTv.movie) {

#line 1012 "pageelems.ecpp"
     for (const auto &character:scraperCharacters) {

#line 1013 "pageelems.ecpp"
       if (character->getType() != eCharacterType::writer) continue;

  reply.out() << _tntChunks[343]; //         <tr>\n          <td class="cast_role"> 
#line 1015 "pageelems.ecpp"
  reply.sout() << ( tr("Writer") );
  reply.out() << _tntChunks[344]; //  </td>\n          <td> 
#line 1016 "pageelems.ecpp"
  reply.sout() << ( character->getPersonName() );
  reply.out() << _tntChunks[345]; //  </td>\n        </tr>\n
#line 1018 "pageelems.ecpp"
     }

#line 1019 "pageelems.ecpp"
     for (const auto &character:scraperCharacters) {

#line 1020 "pageelems.ecpp"
       if (character->getType() != eCharacterType::director) continue;

  reply.out() << _tntChunks[346]; //         <tr>\n          <td class="cast_role"> 
#line 1022 "pageelems.ecpp"
  reply.sout() << ( tr("Director") );
  reply.out() << _tntChunks[347]; //  </td>\n          <td> 
#line 1023 "pageelems.ecpp"
  reply.sout() << ( character->getPersonName() );
  reply.out() << _tntChunks[348]; //  </td>\n        </tr>\n
#line 1025 "pageelems.ecpp"
     }

#line 1026 "pageelems.ecpp"
   }

  reply.out() << _tntChunks[349]; //   </table>\n
#line 1028 "pageelems.ecpp"

  }
}

  reply.out() << _tntChunks[350]; // </div>\n
  reply.out() << _tntChunks[351]; // \n<div id = '
#line 1034 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[352]; // _actors' hidden>\n
#line 1035 "pageelems.ecpp"

if (scraperMovieOrTv.found) {

  reply.out() << _tntChunks[353]; // <table>\n
#line 1039 "pageelems.ecpp"

  const int num_cols = 4;
  int num = 1;
  std::string loc_name;
  getLanguage(loc_name, "LANGUAGE") ||
  getLanguage(loc_name, "LC_ALL") ||
  getLanguage(loc_name, "LC_MESSAGES") ||
  getLanguage(loc_name, "LANG");
  if (loc_name.empty() ) {
    loc_name = std::locale("").name().substr(0,2);
    if (loc_name.length() != 2 || loc_name[0] == 'C' || loc_name[0] == '*' || loc_name[0] == 'L') loc_name = "en"; //  use en as default
  }
  std::string actor_names = "";

  for (const auto &character:scraperCharacters) {
    if (character->getImage().path.empty() ) continue;  // only actors with images
    if (num == 1) {

  reply.out() << _tntChunks[354]; //       <tr>\n
#line 1058 "pageelems.ecpp"
   }

  reply.out() << _tntChunks[355]; //     <td>\n      <a href="/tvscraper/
#line 1060 "pageelems.ecpp"
  reply.sout() << ( character->getImage().path );
  reply.out() << _tntChunks[356]; // " target="_blank">\n        <img src="/tvscraper/
#line 1061 "pageelems.ecpp"
  reply.sout() << ( character->getImage().path );
  reply.out() << _tntChunks[357]; // " alt="
#line 1061 "pageelems.ecpp"
  reply.sout() << (character->getPersonName());
  reply.out() << _tntChunks[358]; // : 
#line 1061 "pageelems.ecpp"
  reply.sout() << (character->getCharacterName());
  reply.out() << _tntChunks[359]; // " class="actor" />\n      </a>\n    </td>\n
#line 1064 "pageelems.ecpp"

    stringAppend(actor_names, "<td><a href=\"https://", loc_name, ".wikipedia.org/wiki/",
      StringUrlEncode(StringReplace(character->getPersonName(), " ", "_")), "\" target=\"_blank\">",
      character->getPersonName(), "</a>");
    actor_names.append(":<br>"); 
    actor_names.append(character->getCharacterName()); 
    actor_names.append("</td>"); 
    if (num == num_cols) {

  reply.out() << _tntChunks[360]; //       </tr>\n      <tr>
#line 1074 "pageelems.ecpp"
  reply.out() << (actor_names);
  reply.out() << _tntChunks[361]; // </tr>\n
#line 1075 "pageelems.ecpp"

      num = 0;
      actor_names = "";
    }
    num++;
  } // for character in scraperCharacters
  if (num != 1) {

  reply.out() << _tntChunks[362]; //     </tr>\n    <tr>
#line 1084 "pageelems.ecpp"
  reply.out() << (actor_names);
  reply.out() << _tntChunks[363]; // </tr>\n
#line 1085 "pageelems.ecpp"

  }

  reply.out() << _tntChunks[364]; // </table>\n
#line 1089 "pageelems.ecpp"

}

  reply.out() << _tntChunks[365]; // </div>\n
  reply.out() << _tntChunks[366]; // \n<div id = '
#line 1094 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[367]; // _artwork' hidden>\n
#line 1095 "pageelems.ecpp"

  const uintptr_t media_p = (uintptr_t)&(scraperMovieOrTv.posters);
  const uintptr_t media_b = (uintptr_t)&(scraperMovieOrTv.banners);
  const uintptr_t media_f = (uintptr_t)&(scraperMovieOrTv.fanarts);

  // <& media ...
  { 
#line 1100 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq34;
#line 1100 "pageelems.ecpp"
    _tnt_cq34.add( "media_p", (media_p));
#line 1100 "pageelems.ecpp"
  main().media(request, reply, _tnt_cq34);
    // &>
  }
  reply.out() << _tntChunks[368]; // \n
  // <& media ...
  { 
#line 1101 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq35;
#line 1101 "pageelems.ecpp"
    _tnt_cq35.add( "media_p", (media_f));
#line 1101 "pageelems.ecpp"
  main().media(request, reply, _tnt_cq35);
    // &>
  }
  reply.out() << _tntChunks[369]; // \n
  // <& media ...
  { 
#line 1102 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq36;
#line 1102 "pageelems.ecpp"
    _tnt_cq36.add( "media_p", (media_b));
#line 1102 "pageelems.ecpp"
  main().media(request, reply, _tnt_cq36);
    // &>
  }
  reply.out() << _tntChunks[370]; // \n</div>\n
  reply.out() << _tntChunks[371]; // \n<div id = '
#line 1105 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[372]; // _epg'>\n\t\t\t\t\t
#line 1106 "pageelems.ecpp"
 reply.out() << StringEscapeAndBreak(long_descr); 
  reply.out() << _tntChunks[373]; // \t\t\t\t</div>\n\t\t\t</div>\n\t\t</div>\n\t</div>\n</div>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::media_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::media " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
uintptr_t media_p = qparam.get< uintptr_t >("media_p");
  // </%args>

#line 59 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 1119 "pageelems.ecpp"

const std::vector<cTvMedia> *media_v = static_cast<std::vector<cTvMedia> *>((void *)media_p);
for (const cTvMedia &media: *media_v) {

  reply.out() << _tntChunks[376]; //   <a href="/tvscraper/
#line 1123 "pageelems.ecpp"
  reply.sout() << ( media.path );
  reply.out() << _tntChunks[377]; // " target="_blank">\n    <img src="/tvscraper/
#line 1124 "pageelems.ecpp"
  reply.sout() << ( media.path );
  reply.out() << _tntChunks[378]; // " class="artwork" />\n  </a>\n
#line 1126 "pageelems.ecpp"

}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::about_tt_box_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::about_tt_box " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 59 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[380]; // \t<div class="epg_description" id="aboutBox">\n\t\t<div class="station">\n\t\t\t<div class="boxheader"><div><div class="caption">
#line 1135 "pageelems.ecpp"
  reply.sout() << ( tr(LIVESUMMARY) );
  reply.out() << _tntChunks[381]; // </div></div></div>\n\t\t</div>\n\t\t<div class="epg_content">\n\t\t\t<div>\n\t\t\t\t<div class="about_head"><div><div>
#line 1139 "pageelems.ecpp"
  reply.sout() << ( tr("Authors") );
  reply.out() << _tntChunks[382]; // </div></div></div>\n\t\t\t\t<div class="about_left">
#line 1140 "pageelems.ecpp"
  reply.sout() << ( tr("Project Idea") );
  reply.out() << _tntChunks[383]; // :</div>\n\t\t\t\t<div class="about_right">Thomas Keil (Thomas)</div>\n\t\t\t\t<div class="about_left">
#line 1142 "pageelems.ecpp"
  reply.sout() << ( tr("Webserver") );
  reply.out() << _tntChunks[384]; // :</div>\n\t\t\t\t<div class="about_right">Sascha Volkenandt (LordJaxom)</div>\n\t\t\t\t<div class="about_left">
#line 1144 "pageelems.ecpp"
  reply.sout() << ( tr("Current Maintainer") );
  reply.out() << _tntChunks[385]; // :</div>\n\t\t\t\t<div class="about_right">Markus Ehrnsperger (MarkusE @ <a href="https://www.vdr-portal.de">VDR Portal</a>)</div>\n\t\t\t\t<div class="about_left">
#line 1146 "pageelems.ecpp"
  reply.sout() << ( tr("Previous Maintainer") );
  reply.out() << _tntChunks[386]; // :</div>\n\t\t\t\t<div class="about_right">Jasmin Jessich (jasminj)</div>\n\t\t\t\t<div class="about_left">
#line 1148 "pageelems.ecpp"
  reply.sout() << ( tr("Project leader") );
  reply.out() << _tntChunks[387]; // :</div>\n\t\t\t\t<div class="about_right">Dieter Hametner (tadi)</div>\n\t\t\t\t<div class="about_left">
#line 1150 "pageelems.ecpp"
  reply.sout() << ( tr("Content") );
  reply.out() << _tntChunks[388]; // :</div>\n\t\t\t\t<div class="about_right">Christian Wieninger (winni)</div>\n\t\t\t\t<div class="about_left">
#line 1152 "pageelems.ecpp"
  reply.sout() << ( tr("Graphics") );
  reply.out() << _tntChunks[389]; // :</div>\n\t\t\t\t<div class="about_right">Michael Br&uuml;ckner (skiller2k1)</div>\n\t\t\t\t<div class="about_head"><div><div>
#line 1154 "pageelems.ecpp"
  reply.sout() << ( tr("Information") );
  reply.out() << _tntChunks[390]; // </div></div></div>\n\t\t\t\t<div class="about_left">
#line 1155 "pageelems.ecpp"
  reply.sout() << ( tr("LIVE version") );
  reply.out() << _tntChunks[391]; // :</div>\n\t\t\t\t<div class="about_right">
#line 1156 "pageelems.ecpp"
  reply.sout() << ( LIVEVERSION );
#line 1156 "pageelems.ecpp"
  reply.sout() << ( VERSION_SUFFIX );
  reply.out() << _tntChunks[392]; // </div>\n\t\t\t\t<div class="about_left">
#line 1157 "pageelems.ecpp"
  reply.sout() << ( tr("VDR version") );
  reply.out() << _tntChunks[393]; // :</div>\n\t\t\t\t<div class="about_right">
#line 1158 "pageelems.ecpp"
  reply.sout() << ( VDRVERSION );
  reply.out() << _tntChunks[394]; // </div>\n\t\t\t\t<div class="about_head"><div><div>
#line 1159 "pageelems.ecpp"
  reply.sout() << ( tr("Features") );
  reply.out() << _tntChunks[395]; // </div></div></div>\n\t\t\t\t<div class="about_left">EPGsearch:</div>\n\t\t\t\t<div class="about_right">\n
#line 1162 "pageelems.ecpp"
					Features< features::epgsearch >& epgsearch = LiveFeatures< features::epgsearch >();

  reply.out() << _tntChunks[396]; // \t\t\t\t\t<img align="center" src="
#line 1163 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", epgsearch.Recent() ? "active.png" : "inactive.png") );
  reply.out() << _tntChunks[397]; // "/>\n
#line 1164 "pageelems.ecpp"
					if ( epgsearch.Recent() ) {

  reply.out() << _tntChunks[398]; // \t\t\t\t\t\t
#line 1165 "pageelems.ecpp"
  reply.sout() << ( tr("active") );
  reply.out() << _tntChunks[399]; // : 
#line 1165 "pageelems.ecpp"
  reply.sout() << ( epgsearch.Version() );
  reply.out() << _tntChunks[400]; // \n
#line 1166 "pageelems.ecpp"
					} else {

  reply.out() << _tntChunks[401]; // \t\t\t\t\t\t
#line 1167 "pageelems.ecpp"
  reply.sout() << ( tr("required") );
  reply.out() << _tntChunks[402]; // : 
#line 1167 "pageelems.ecpp"
  reply.sout() << ( epgsearch.MinVersion() );
  reply.out() << _tntChunks[403]; // \n
#line 1168 "pageelems.ecpp"
					}

  reply.out() << _tntChunks[404]; // \t\t\t\t\t(<a href="https://github.com/vdr-projects/vdr-plugin-epgsearch" target="_blank">
#line 1169 "pageelems.ecpp"
  reply.sout() << ( tr("Homepage") );
  reply.out() << _tntChunks[405]; // </a>)<br/>\n\t\t\t\t</div>\n\t\t\t\t<div class="about_left">Streamdev server:</div>\n\t\t\t\t<div class="about_right">\n
#line 1173 "pageelems.ecpp"

					Features< features::streamdev_server >& streamdev = LiveFeatures< features::streamdev_server >();

  reply.out() << _tntChunks[406]; // \t\t\t\t\t<img align="center" src="
#line 1176 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", streamdev.Loaded() ? "active.png" : "inactive.png") );
  reply.out() << _tntChunks[407]; // "/>\n
#line 1177 "pageelems.ecpp"

					if ( streamdev.Loaded() ) {

  reply.out() << _tntChunks[408]; // \t\t\t\t\t\t
#line 1180 "pageelems.ecpp"
  reply.sout() << ( tr("active") );
  reply.out() << _tntChunks[409]; // : 
#line 1180 "pageelems.ecpp"
  reply.sout() << ( streamdev.Version() );
  reply.out() << _tntChunks[410]; // \n
#line 1181 "pageelems.ecpp"

					} else {

  reply.out() << _tntChunks[411]; // \t\t\t\t\t\t
#line 1184 "pageelems.ecpp"
  reply.sout() << ( tr("required") );
  reply.out() << _tntChunks[412]; // : 
#line 1184 "pageelems.ecpp"
  reply.sout() << ( streamdev.MinVersion() );
  reply.out() << _tntChunks[413]; // \n
#line 1185 "pageelems.ecpp"

					}

  reply.out() << _tntChunks[414]; // \t\t\t\t\t(<a href="https://github.com/vdr-projects/vdr-plugin-streamdev" target="_blank">
#line 1188 "pageelems.ecpp"
  reply.sout() << ( tr("Homepage") );
  reply.out() << _tntChunks[415]; // </a>)<br/>\n\t\t\t\t</div>\n\t\t\t\t<div class="about_left">tvscraper:</div>\n\t\t\t\t<div class="about_right">\n
#line 1192 "pageelems.ecpp"
					Features< features::tvscraper >& tvscraper = LiveFeatures< features::tvscraper >();

  reply.out() << _tntChunks[416]; // \t\t\t\t\t<img align="center" src="
#line 1193 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", tvscraper.Recent() ? "active.png" : "inactive.png") );
  reply.out() << _tntChunks[417]; // "/>\n
#line 1194 "pageelems.ecpp"
					if ( tvscraper.Recent() ) {

  reply.out() << _tntChunks[418]; // \t\t\t\t\t\t
#line 1195 "pageelems.ecpp"
  reply.sout() << ( tr("active") );
  reply.out() << _tntChunks[419]; // : 
#line 1195 "pageelems.ecpp"
  reply.sout() << ( tvscraper.Version() );
  reply.out() << _tntChunks[420]; // \n
#line 1196 "pageelems.ecpp"
					} else {

  reply.out() << _tntChunks[421]; // \t\t\t\t\t\t
#line 1197 "pageelems.ecpp"
  reply.sout() << ( tr("required") );
  reply.out() << _tntChunks[422]; // : 
#line 1197 "pageelems.ecpp"
  reply.sout() << ( tvscraper.MinVersion() );
  reply.out() << _tntChunks[423]; // \n
#line 1198 "pageelems.ecpp"
					}

  reply.out() << _tntChunks[424]; // \t\t\t\t\t(<a href="https://github.com/MarkusEh/vdr-plugin-tvscraper" target="_blank">
#line 1199 "pageelems.ecpp"
  reply.sout() << ( tr("Homepage") );
  reply.out() << _tntChunks[425]; // </a>)<br/>\n\t\t\t\t</div>\n\t\t\t\t<div class="about_head"><div><div>
#line 1201 "pageelems.ecpp"
  reply.sout() << ( tr("Information providers") );
  reply.out() << _tntChunks[426]; // </div></div></div>\n\t\t\t\t<div class="about_line">Movie information provided by <a target="_blank" href="https://www.themoviedb.org/">TMDB</a>. This product uses the TMDB API but is not endorsed or certified by TMDB</div>\n\t\t\t\t<div class="about_line">Information provided by TheTVDB.com. Please consider <a target="_blank" href="https://u10505776.ct.sendgrid.net/ls/click\?upn=xMYYCP13hVd-2BZPpbVcMPHeLXfv-2BPRdIsKm2qSeirIHi7kH9am8IxD-2BavFbeqGqIXIcjH_INgc0CXRkIvGU-2BJ1W6HLAynNbR0UBoMb2tkpDdezO3QRj-2FQPQAMrtJKVcB0N7eSvbYpjQTDNOQBf2pb94uDgGr0-2BXyXFk7Oyfva30BASYCRLvtRQyi5eOCAbH8fon7UETlPydobeLA3Recu9OsXol8c7Ng4pDAsH6KsFF8CH7HQoVxivnpKrQW2v4ek7U-2BYlWmH31o9Koke3vq-2FDsQ0P-2BiKLECU3LgttsntUcN8fnUs-3D">supporting them</a></div>\n\t\t\t\t<div class="about_head"><div><div>
#line 1204 "pageelems.ecpp"
  reply.sout() << ( tr("Bugs and suggestions") );
  reply.out() << _tntChunks[427]; // </div></div></div>\n\t\t\t\t<div class="about_line">
#line 1205 "pageelems.ecpp"
  reply.sout() << ( tr("If you encounter any bugs or would like to suggest new features, please use our bugtracker") );
  reply.out() << _tntChunks[428]; // :<br/>\n\t\t\t\t\t<a target="_blank" href="https://github.com/MarkusEh/vdr-plugin-live/issues">https://github.com/MarkusEh/vdr-plugin-live/issues</a></div>\n\t\t\t\t<div class="about_head"><div><div>&nbsp;</div></div></div>\n\t\t\t</div>\n\t\t</div>\n\t</div>\n
  // <%/cpp>
  return DEFAULT;
}

} // namespace
